<?php
    print("
        <form class=\"form-stacked\" method=\"POST\" action=\"".$parser->makeUrl($parser->pageId)."\">
            <div class=\"row\">
                <div class=\"span5 offset5\">
                    <label for=\"login_username\">Username:</label>
                    <input type=\"text\" id=\"login_username\" name=\"login_username\" placeholder=\"username\" />

                    <label for=\"login_password\">Password:</label>
                    <input type=\"password\" id=\"login_password\" name=\"login_password\" placeholder=\"password\" />

                </div>
            </div>
            <div class=\"actions\">
                <button type=\"submit\" name=\"login_submit\" class=\"btn primary large\">Get user info</button>
            </div>
        </form>
    ");

    if(isset($_POST['login_username']))
    {
        print('<br>');
        include_once(SYS_BASE_PATH.'ext/common/apiclient.php');

        $api = new apiclient();
        /*

        // 1. JSON
        try
        {
            $api->clientid = 'apitest_client1';
            $api->clientkey = '123456789011121314151617181920';
            $api->url = 'http://localhost/wdelo30/api/index.php';
            $api->controller = 'test';
            $api->httppsw = '';
            $api->httpuser = '';
            $api->action = 'index';
            $api->controller_to_url = false;

            $data = $api->sendRequest(array(
                'login' => $_POST['login_username'],
                'password' => $_POST['login_password']
            ));

            var_dump($data);

        } catch (Exception $e) { echo $e->getMessage();}

        */

        // 2. XML

        try
        {
            $api->clientid = 'apitest_client1';
            $api->clientkey = '123456789011121314151617181920';
            $api->url = 'http://localhost/wdelo30/api/index.php';
            $api->controller = 'test';
            $api->httpuser = '';
            $api->httppsw = '';
            $api->action = 'index';
            $api->return_format = 'xml';
            $api->controller_to_url = false;

            $data = $api->sendRequest(array(
                'login' => $_POST['login_username'],
                'password' => $_POST['login_password']
            ));

            foreach($data->children() as $child)
            {
                print("<br>");
                print($child->getName());
                print(" = ");
                print((string)$child);
            }

        } catch (Exception $e) { echo $e->getMessage();}

    }


?>