<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wprod_rights_products');
    if(!$perm['r']) die($parser->gt('not_perms'));
    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
    $w = new wAjaxGrid();

    $filter_productid = (isset($_REQUEST['filter_productid'])) ? $_REQUEST['filter_productid'] : '';
    $filter_confirmed = (isset($_REQUEST['filter_confirmed'])) ? $_REQUEST['filter_confirmed'] : '';
    $filter_period = (isset($_REQUEST['filter_period'])) ? $_REQUEST['filter_period'] : 1;

    $active_tab =  (isset($active_tab)) ? $active_tab : '0';
    $cat_id =  (isset($cat_id)) ? $cat_id : '0';
    $callbackfunc =  (isset($callbackfunc)) ? $callbackfunc : '';

    if($cat_id)
    {
        $filter_productid = $cat_id;
        $filter_period = 0;
    }


    $w->f = new wproducts_models_booking();
    $w->edit_table_alias = 'o';
    //$w->caption = $parser->gt('wprod_booking', __FILE__);
    $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_booking'", '');
    $prod_col = 0;
    $prodid_col = 0;
    $w->q->select('o.id',  $parser->gt('id'));
    if(!$cat_id) $prod_col = $w->q->lselect('p.name', $parser->gt('product'));
    $w->q->select('o.starton', $parser->gt('starton'));
    $w->q->select('o.finishon', $parser->gt('finishon'));
    $w->q->select('o.firstname', $parser->gt('firstname'), array('edit' => $perm['u']));
    $w->q->select('o.phone', $parser->gt('telephone'), array('edit' => $perm['u']));
    $w->q->select('o.needtransfer', $parser->gt('needtransfer'));

    $w->q->from('wprod_booking o');
    $w->q->where("o.id<>'0'");
    $w->q->orderby('o.id DESC');

    if(!$cat_id)
    {
        $prodid_col = $w->q->select('o.productid',  $parser->gt('productid'), array('hide' =>true));
        $w->q->from('wprod_products p');
        $w->q->where("o.productid=p.id");
    }
    if($filter_period)
    {
         $per = $parser->utils->getPeriod($filter_period, true);
         $w->q->where("o.starton ".$per);
         $w->f->extra_deleteAll_sql .= "AND (starton ".$per.")";
    }
    $w->q->select('o.confirmed', $parser->gt('confirmed'));
    switch($filter_confirmed)
    {
        case 1:	 $w->q->where("o.confirmed=1");
                 $w->f->extra_deleteAll_sql .= "AND confirmed=1 ";
        break;
        case 2:	 $w->q->where("o.confirmed=0");
                 $w->f->extra_deleteAll_sql .= "AND confirmed=0 ";
        break;
    }
    if($filter_productid)
    {
        $mfilter_productid = $filter_productid;
        $w->q->where("o.productid IN(".$mfilter_productid.")");
        $w->f->extra_deleteAll_sql .= "AND productid IN(".$mfilter_productid.") ";
        $w->f->fields->productid->val = $filter_productid;
        $w->f->fields->productid->refval = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM wprod_products WHERE id=".$filter_productid, '');
        $w->f->fields->productid->ro = true;
    }
    $pars = array();
    $pars['onchange'] = $w->container."_postAction('',0)";
    $pars['name'] = 'filter_period';
    $pars['val'] = $filter_period;
    $w->addCell($parser->utils->periodMenu($pars));

    $pars = array();
    $pars['onchange'] = $w->container."_postAction('',0)";
    $pars['name'] = 'filter_confirmed';
    $pars['val'] = $filter_confirmed;
    $pars['options'] = array($parser->gt('all'), $parser->gt('confirmed'), $parser->gt('notconfirmed'));
    $w->addCell($parser->utils->dropdownMenu($pars));

    if(!$cat_id)
    {
        $w->popup_script = true;
        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_productid';
        $pars['emptyval'] = 0;
        $pars['tree_btn'] = 0;
        $pars['emptyrefval'] = $parser->gt('allproducts');
        $pars['val'] = $filter_productid;
        $pars['objtype'] = 'wprod_products';
        $pars['extra_pars'] = " AND (prodtype='wprod_prodtypes_estate') ";
        $w->addCell($parser->utils->finder($pars));
    }

    $w->addSearchField('o.productid', $parser->gt('product'), 'wprod_products');
    $w->addSearchField('o.firstname', $parser->gt('firstname'), 'C');
    $w->addSearchField('o.phone', $parser->gt('telephone'), 'C');
    $w->addSearchField('o.email', $parser->gt('email'), 'C');
    $w->addSearchField('o.adults', $parser->gt('numberadults'), 'I');
    $w->addSearchField('o.children', $parser->gt('numberchildren'), 'I');
    $w->addSearchField('o.notes', $parser->gt('notes'), 'C');
    $w->addSearchField('o.needtransfer', $parser->gt('needtransfer'), 'L');
    $w->addSearchField('o.flightinfo', $parser->gt('flightinfo'), 'C');


    $w->editing = $perm['u'];
    $w->adding = $perm['c'];
    $w->copying = $perm['c'];
    $w->deleting = $perm['d'];
    $w->multiselect = $perm['d'];


    $w->addHidden('active_tab', $active_tab);
    $w->addHidden('cat_id', $cat_id);
    $w->addHidden('callbackfunc', $callbackfunc);

    if($perm['c'])
    {
        $w->addMainMenu0($parser->gt('import', SYS_BASE_PATH.'main/objects'), 'javascript:dataimport');
    	$src = SYS_BASE_URL.'main/js/popup.js';
        $parser->addScript($src);
        $src = "
        <script type='text/javascript'>
        function dataimport(obj)
        {
            openWinc('".$parser->makeUrl('sys_admin_utils_import')."', 'callbackfunc=self.opener.global_".$w->container.".loadxml(0)&exp_objtype=wprod_booking');
        }
        </script>
        ";
        $parser->addScript($src);
    }

    if(!$cat_id) $w->addCard($prod_col, $prodid_col, $parser->makeUrl('wprod_products_card'));

    $w->show();
?>