<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wprod_rights_prodcats');
    if(!$perm['r']) die($parser->gt('not_perms'));

    $active_tab =  (isset($active_tab)) ? $active_tab : '0';
    $cat_id =  (isset($cat_id)) ? $cat_id : '0';
    $callbackfunc =  (isset($callbackfunc)) ? $callbackfunc : '';

    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
    $w = new wAjaxGrid();
    $filter_categoryid = (isset($_REQUEST['filter_categoryid'])) ? $_REQUEST['filter_categoryid'] : '';
    $filter_lang = (isset($_REQUEST['filter_lang'])) ? $_REQUEST['filter_lang'] : '';
    $w->f = new wproducts_models_categorieslang();
    $w->edit_table_alias = 'o';
    //$w->caption = $parser->gt('wprod_categories_lang', __FILE__);
    $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_categories_lang'", '');
    if($cat_id)
    {
        $filter_categoryid= $cat_id;
    }

    $w->q->select('o.id',  $parser->gt('id'));
    $w->q->select('o.lang', $parser->gt('language'));
    if(!$cat_id) $w->q->lselect('p.name AS pname', $parser->gt('category'), array('hide' => $filter_categoryid));
    $w->q->select('o.name', $parser->gt('name'), array('edit' => $perm['u']));
    $w->q->select('o.meta_title', $parser->gt('meta-title'), array('edit' => $perm['u']));
    $w->q->select('o.meta_h1', $parser->gt('meta-h1'), array('edit' => $perm['u']));
    $w->q->select('o.url', $parser->gt('url'), array('edit' => $perm['u']));

    $w->q->from('wprod_categories_lang o');
    $w->q->from('wprod_categories p');
    $w->q->where("o.id<>'0'");
    $w->q->where("o.categoryid=p.id");
    $w->q->orderby('o.name');

    $extrasql = '';
    $extrasql_cat = '';
    if($filter_categoryid)
    {
        $mfilter_categoryid = $parser->utils->addQuots($filter_categoryid);
        $w->q->where("o.categoryid IN(".$mfilter_categoryid.")");
        $w->f->extra_deleteAll_sql .= "AND categoryid IN(".$mfilter_categoryid.") ";
        $w->f->fields->categoryid->val = $filter_categoryid;
        $extrasql .= "AND categoryid IN(".$mfilter_categoryid.") ";
        $extrasql_cat .= "AND id IN(".$mfilter_categoryid.") ";
    }

    if($filter_lang)
    {
        $w->q->where("o.lang='".$filter_lang."'");
        $w->f->extra_deleteAll_sql .= "AND lang='".$filter_lang."' ";
        $w->f->fields->lang->val = $filter_lang;
        $extrasql .= "AND lang='".$filter_lang."' ";
    }

    $pars = array();
    $pars['onchange'] = $w->container."_postAction('',0)";
    $pars['name'] = 'filter_lang';
    $pars['val'] = $filter_lang;
    $pars['options'] = array();
    $pars['options'][] = $parser->gt('alllanguages').':';

    $rs = $parser->conn->Execute("SELECT objid, name_".$parser->lang_suff.", str1_".$parser->lang_suff.
    " FROM sys_objects WHERE objtype='sys_langs' and bool1=1");
    while($row = $rs->FetchRow())
    {
        $pars['options'][] = $row[1].':'.$row[2];
    }
    $w->addCell($parser->utils->dropdownMenu($pars));

    if(!$cat_id)
    {
        $w->popup_script = true;
        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_categoryid';
        $pars['emptyval'] = 0;
        $pars['tree_btn'] = 0;
        $pars['emptyrefval'] = $parser->gt('allcategories');
        $pars['val'] = $filter_categoryid;
        $pars['objtype'] = 'wprod_categories';
        $w->addCell($parser->utils->finder($pars));
    }

    if(!$cat_id) $w->laddSearchField('p.name', $parser->gt('category'));
    $w->addSearchField('o.name', $parser->gt('name'), 'C');
    $w->addSearchField('o.description', $parser->gt('description'), 'C');
    $w->addSearchField('o.url', $parser->gt('url'), 'C');
    $w->addSearchField('o.meta_title', $parser->gt('meta-title'), 'C');
    $w->addSearchField('o.meta_h1', $parser->gt('meta-h1'), 'C');
    $w->addSearchField('o.meta_keywords', $parser->gt('meta-keywords'), 'C');
    $w->addSearchField('o.meta_description', $parser->gt('meta-description'), 'C');
    $w->addSearchField('o.categoryid', $parser->gt('category'), 'wprod_categories');

    $w->editing = $perm['u'];
    $w->adding = $perm['c'];
    $w->copying = $perm['c'];
    $w->deleting = $perm['d'];
    $w->multiselect = $perm['d'];

    $w->addHidden('active_tab', $active_tab);
    $w->addHidden('cat_id', $cat_id);
    $w->addHidden('callbackfunc', $callbackfunc);

    if($perm['c'])
    {
        $w->addMainMenu0($parser->gt('import', SYS_BASE_PATH.'main/objects'), 'javascript:dataimport');
    	$src = SYS_BASE_URL.'main/js/clean/popup.js';
        $parser->addScript($src);
        $src = "
        <script type='text/javascript'>
        function dataimport(obj)
        {
            openWinc('".$parser->makeUrl('sys_admin_utils_import')."', 'callbackfunc=self.opener.global_".$w->container.".loadxml(0)&exp_objtype=wprod_categories_lang');
        }
        </script>
        ";
        $parser->addScript($src);
    }

    if($perm['u'])
    {
        $form_action = (isset($_REQUEST['form_action'])) ? $_REQUEST['form_action'] : '';
        switch($form_action)
        {
            case 'makeurls':
                @set_time_limit(0);
                $rs = $parser->conn->Execute("SELECT id, name, url, lang, categoryid
                            FROM wprod_categories_lang WHERE (id>0) ".$extrasql);
                $output = '';
                while($row = $rs->FetchRow())
                {
                    $url = trim($row[2]);
                    if($url) continue;
                    $lang = trim($row[3]);
                    $url = '';
                    switch($lang)
                    {
                        case 'ru':
                        case 'ua':
                            $url = $parser->utils->ruTranslit(mb_strtolower(trim($row[1]), $this->config['charset']));
                            $url = str_replace(array(" ", "_", "&", "+", ".", ",", "/", "*", "'", "\"", "%", "(", ")", "?"),
                                               array("-", "-", "-", "-", "-", "-", "-", "-", "-", "-",  "-", "-", "-", "-"),
                                               $url);
                            $url = preg_replace('/[\-]+/','-', $url);
                            $url = trim($url, '-');
                            $url = preg_replace('/[^A-Za-z0-9\-]/', '', $url);

                            // Check uniqueness in categories_lang
                            $n = $parser->utils->getFieldFromSql("SELECT id FROM wprod_categories_lang
                                                                  WHERE (url='".$this->conn->escape($url)."')
                                                                  AND (id<>".$row[0].")", 0);

                            // Check uniqueness in products_lang
                            if(!$n)
                            {
                                $n = $parser->utils->getFieldFromSql("SELECT id FROM wprod_products_lang
                                                                      WHERE (url='".$this->conn->escape($url)."')
                                                                      AND (id<>0)", 0);
                            }
                            // Check uniqueness in Products
                            if(!$n)
                            {
                                $n = $parser->utils->getFieldFromSql("SELECT id FROM wprod_products
                                                                      WHERE (url='".$this->conn->escape($url)."')
                                                                      AND (id<>0)", 0);
                            }
                            if(!$n)
                            {
                                // Check uniqueness in Categoris
                                $n = $parser->utils->getFieldFromSql("SELECT id FROM wprod_categories
                                                                      WHERE (url='".$this->conn->escape($url)."')
                                                                      AND (id>0)", 0);

                            }
                            if(!$n)
                            {
                                // Check uniqueness in Pages
                                $n = $parser->utils->getFieldFromSql("SELECT objid FROM sys_objects
                                                                      WHERE (pagealias='".$this->conn->escape($url)."')
                                                                      AND (objtype='sys_elements_pages')", 0);

                            }

                        break;
                    }
                    if(!$url) continue;


                    if($n) $url .= '-'.$lang.'-categories-'.$row[0];
                    $parser->conn->Execute("UPDATE wprod_categories_lang set url='".$url."' WHERE id=".$row[0]);
                }
            break;
            case 'clearurls':
                    $parser->conn->Execute("UPDATE wprod_categories_lang set url=''");
            break;
            case 'makelangs':
                $rs = $parser->conn->Execute("SELECT id
                            FROM wprod_categories WHERE (id>0) ".$extrasql_cat);
                $f = new wproducts_models_categories();
                while($row = $rs->FetchRow())
                {
                    $f->id = $row[0];
                    $f->read();
                    $f->update();
                }
            break;
        }

        $action =  (isset($_POST["action"])) ? $_POST["action"] : '';
        $metafld = 'meta_description';
        switch($action)
        {
            case 'clearmetadesc':
            case 'makemetadesc':
                $metafld = 'meta_description';
            break;
            case 'clearmetah1':
            case 'makemetah1':
                $metafld = 'meta_h1';
            break;
            case 'clearmetatitle':
            case 'makemetatitle':
                $metafld = 'meta_title';
            break;
        }


        switch($action)
        {
            case 'clearmetah1':
            case 'clearmetatitle':
            case 'clearmetadesc':
                        if(!$filter_lang)
                        {
                            if(ob_get_length()) ob_clean();
                                    print($parser->gt('chooselang'));
                            exit;

                        }
                        $i = 0;
                        $rs = $parser->conn->Execute("SELECT id
                                    FROM wprod_categories WHERE (id>0) ".$extrasql_cat);
                        $f = new wproducts_models_categories();

                        $ff = new wproducts_models_categorieslang();

                        while($row = $rs->FetchRow())
                        {
                            $f->id = $row[0];
                            $f->read();
                            if($filter_lang === $parser->config['seo_default_lang'])
                            {
                                // For default lang
                                $f->fields->$metafld->val = '';
                                $f->update();
                                $i++;
                            } else
                            {
                                // Not default lang
                                $ff->id = $parser->utils->getFieldFromSql("SELECT id FROM wprod_categories_lang
                                                                           WHERE categoryid=".$row[0]."
                                                                           AND lang='".$filter_lang."'", 0);
                                if(!$ff->id) continue;
                                $ff->read();
                                $ff->fields->$metafld->val = '';
                                $ff->update();
                                $i++;
                            }
                        }
                        if(ob_get_length()) ob_clean();
                                print($parser->gt('imakemetadesccompletec', '', $i));
                        exit;
            break;
            case 'makemetah1':
            case 'makemetatitle':
            case 'makemetadesc':
                        if(!$filter_lang)
                        {
                            if(ob_get_length()) ob_clean();
                                    print($parser->gt('chooselang'));
                            exit;

                        }
                        $template =  (isset($_POST['makemetadesc'])) ? $_POST['makemetadesc'] : '';

                        $i = 0;
                        $rs = $parser->conn->Execute("SELECT id
                                    FROM wprod_categories WHERE (id>0) ".$extrasql_cat);
                        $f = new wproducts_models_categories();

                        $ff = new wproducts_models_categorieslang();

                        while($row = $rs->FetchRow())
                        {
                            $f->id = $row[0];
                            $f->read();
                            if($filter_lang === $parser->config['seo_default_lang'])
                            {
                                // For default lang
                                $makemetadesc = str_replace('[CATEGORY_NAME]', $f->fields->name->val, $template);
                                if(trim($f->fields->$metafld->val)) continue;
                                $f->fields->$metafld->val = $makemetadesc;
                                $f->update();
                                $i++;
                            } else
                            {
                                // Not default lang
                                $ff->id = $parser->utils->getFieldFromSql("SELECT id FROM wprod_categories_lang
                                                                           WHERE categoryid=".$row[0]."
                                                                           AND lang='".$filter_lang."'", 0);
                                if(!$ff->id) continue;
                                $ff->read();
                                $makemetadesc = str_replace('[CATEGORY_NAME]', $ff->fields->name->val, $template);
                                if(trim($ff->fields->$metafld->val)) continue;
                                $ff->fields->$metafld->val = $makemetadesc;
                                $ff->update();
                                $i++;
                            }

                        }
                        if(ob_get_length()) ob_clean();
                                print($parser->gt('imakemetadesccompletec', '', $i));
                        exit;
            break;
        }

        $w->addMainMenu0($parser->gt('functions'));
        $w->addMainMenu1($parser->gt('makeurls'), 'javascript:makeurls');
        $w->addMainMenu1($parser->gt('clearurls'), 'javascript:clearurls');
        $w->addMainMenu1($parser->gt('makelangs'), 'javascript:makelangs');
        if($parser->config['seo_default_lang'])
        {
            $w->addMainMenu1('------------------','1','');
            $w->addMainMenu1($parser->gt('makemetadesc'), 'makemetadesc', (!$filter_lang) ? $parser->gt('chooselang') :
            $parser->gt('makemetadesc')."<br /><textarea name='makemetadesc' cols=\"60\" rows=\"10\">[CATEGORY_NAME]</textarea>");
            $w->addMainMenu1($parser->gt('clearmetadesc'), 'clearmetadesc', (!$filter_lang) ? $parser->gt('chooselang') :
            $parser->gt('clearmetadesc')."?");

            $w->addMainMenu1('------------------','2','');
            $w->addMainMenu1($parser->gt('makemetah1'), 'makemetah1', (!$filter_lang) ? $parser->gt('chooselang') :
            $parser->gt('makemetah1')."<br /><textarea name='makemetadesc' cols=\"60\" rows=\"10\">[CATEGORY_NAME]</textarea>");
            $w->addMainMenu1($parser->gt('clearmetah1'), 'clearmetah1', (!$filter_lang) ? $parser->gt('chooselang') :
            $parser->gt('clearmetah1')."?");

            $w->addMainMenu1('------------------','3','');
            $w->addMainMenu1($parser->gt('makemetatitle'), 'makemetatitle', (!$filter_lang) ? $parser->gt('chooselang') :
            $parser->gt('makemetatitle')."<br /><textarea name='makemetadesc' cols=\"60\" rows=\"10\">[CATEGORY_NAME]</textarea>");
            $w->addMainMenu1($parser->gt('clearmetatitle'), 'clearmetatitle', (!$filter_lang) ? $parser->gt('chooselang') :
            $parser->gt('clearmetatitle')."?");
        }

        $src = "<script type=\"text/javascript\">
        function makeurls(obj)
        {
            ".$w->container."_postAction('makeurls', 0);
        }
        function clearurls(obj)
        {
            var q = window.confirm(\"".$parser->gt('atclearurls')."\");
            if(!q) return;
            ".$w->container."_postAction('clearurls', 0);
        }
        function makelangs(obj)
        {
            var q = window.confirm(\"".$parser->gt('atmakelangs')."\");
            if(!q) return;
            ".$w->container."_postAction('makelangs', 0);
        }
    	</script>";
        $parser->addScript($src);
    }

    $w->show();
?>