<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));

    include_once(SYS_BASE_PATH.'main/classes/ckdial.class.php');
    class ckdialm extends ckdial
    {
        public function execAction()
        {
            global $parser;
            @set_time_limit(0);

            if($this->_ckboxes['products']['val'])
            {
                $parser->conn->Execute("DELETE FROM wprod_rcomments WHERE id>0");
                $parser->conn->Execute("DELETE FROM wprod_comments WHERE id>0");
                $parser->conn->Execute("DELETE FROM wprod_reviews WHERE id>0");
                $parser->conn->Execute("DELETE FROM wprod_products_prop WHERE id>0");
                $parser->conn->Execute("DELETE FROM wprod_products_photo WHERE id>0");
                $parser->conn->Execute("DELETE FROM wprod_products_attr WHERE id>0");
                $parser->conn->Execute("DELETE FROM wprod_products_lang WHERE id>0");
                @$parser->conn->Execute("DELETE FROM wprod_nofound WHERE id>0");
                if(!$parser->conn->Execute("DELETE FROM wprod_products WHERE id>0"))
                {
                    print($parser->gt('cannotclear', __FILE__).' '.$parser->gtl('products', __FILE__));
                    exit;
                }
                $parser->utils->removeDir(SYS_BASE_PATH.'userdata/modules/wproducts/wprod_products', true, true);
                $parser->utils->removeDir(SYS_BASE_PATH.'userdata/modules/wproducts/wprod_products_photo', true, true);
            }
            if($this->_ckboxes['categories']['val'])
            {
                if(!$parser->conn->Execute("DELETE FROM wprod_categories WHERE id>0"))
                {
                    print($parser->gt('cannotclear', __FILE__).' '.$parser->gtl('categories', __FILE__));
                    exit;
                }
                $parser->conn->Execute("DELETE FROM wprod_categories_lang WHERE id>0");
                $parser->utils->removeDir(SYS_BASE_PATH.'userdata/modules/wproducts/avatars/wprod_categories', true, true);
            }
            if($this->_ckboxes['manufacters']['val'])
            {
                include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
                $parser->enlogging = false;
                $killer = new wPrototype();

                $killer->table = 'sys_objects';
                $killer->keyfield = 'objid';
                $killer->namefield = 'name';
                $killer->namefield_lang = 1;
                $killer->_setObjType();
                $killer->_setFieldsFromSchema();

                // Clear galleries
                $sql = "SELECT o.objid, o.objtype, o.isfolder, o.parent
                        FROM sys_objects o, sys_objects m
                        WHERE (o.objtype='wprod_brands')
                        AND (o.ref1=m.objid)";
                $rs = $parser->conn->Execute($sql);

                if($rs and ($rs->NumRows() >= 1))
                {
                    while($row = $rs->FetchRow())
                    {
                        if(!$row[0]) continue;
                        $killer->objtype = 'sys_site_gallery';
                        $killer->id = $row[0];
                        $killer->setFieldNewVal('parent', $row[3]);
                        $s = $killer->delete();
                        if($s)
                        {
                            print($parser->gt('cannotclear', __FILE__).' '.$parser->gtl('manufacters', __FILE__).' '.$s);
                            exit;
                        }
                    }
                }
            }

            if($this->_ckboxes['lineup']['val'])
            {
                if(!$parser->conn->Execute("DELETE FROM wprod_lineup_attr WHERE id>0"))
                {
                    print($parser->gt('cannotclear', __FILE__).' '.$parser->gtl('lineup', __FILE__));
                    exit;
                }
                if(!$parser->conn->Execute("DELETE FROM wprod_lineups WHERE id>0"))
                {
                    print($parser->gt('cannotclear', __FILE__).' '.$parser->gtl('lineup', __FILE__));
                    exit;
                }
                $parser->conn->Execute("UPDATE wprod_products SET lineupid=0  WHERE id>0");
            }

            if(ob_get_length()) ob_clean();
            print('ok');
            exit;
        }
    }

    $f = new ckdialm();
    $f->ok_mes = $parser->gt('clearedok', __FILE__);
    $f->btn_caption = $parser->gt('clear', __FILE__);
    $f->addCkbox('categories', $parser->gt('categories', __FILE__), 1);
    $f->addCkbox('products', $parser->gt('products', __FILE__), 1);
    $f->addCkbox('manufacters', $parser->gt('manufacters', __FILE__), 0);
    $f->addCkbox('lineup', $parser->gt('lineup', SYS_BASE_PATH.'ext/wproducts'), 0);
    $f->show();


?>