<?php
    // Check Rights
    $fn = __FILE__;
    if(!$parser->getUserId()) die($parser->gt('not_perms'));



    include_once(SYS_BASE_PATH.'main/utils/import.class.php');
    class imradprodimport extends wcatimport
    {
        public $filter_category = 0;
        public $filter_manufacter = 0;
        public $filter_prodfields = 0;
        public $filter_charfields = 0;

        public function onbeforeshowfilelist($pars = array())
        {
            global $parser;
            $grid = $pars['grid'];
            $grid->popup_script = true;
            $ppars = array();
            $ppars['name'] = 'filter_category';
            $ppars['val'] = $this->filter_category;
            $ppars['emptyval'] = 0;
            //$ppars['tree_btn'] = 0;
            $ppars['emptyrefval'] = $parser->gt('allcategories', SYS_BASE_PATH.'ext/wproducts');
            $ppars['onchange'] = "filemanager_grid_postAction('',0)";
            $ppars['objtype'] = 'wprod_categories';
            $grid->addCell($parser->utils->finder($ppars));

            $w->popup_script = true;
            $ppars = array();
            $ppars['name'] = 'filter_manufacter';
            $ppars['val'] = $this->filter_manufacter;
            $ppars['emptyval'] = 0;
            $ppars['tree_btn'] = 0;
            $ppars['emptyrefval'] = $parser->gt('allmanufacter', SYS_BASE_PATH.'ext/wproducts');
            $ppars['onchange'] = "filemanager_grid_postAction('',0)";
            $ppars['objtype'] = 'wprod_brands';
            $grid->addCell($parser->utils->finder($ppars));

            $ppars = array();
            $ppars['name'] = 'filter_prodfields';
            $ppars['val'] = $this->filter_prodfields;
            $ppars['options'] = array($parser->gt('allgoodsfields'), $parser->gt('onlyenames'), $parser->gt('onlyexported'));
            $grid->addCell($parser->utils->dropdownMenu($ppars));

            $ppars = array();
            $ppars['name'] = 'filter_charfields';
            $ppars['val'] = $this->filter_charfields;
            $ppars['options'] = array($parser->gt('allcharfields'), $parser->gt('onlyemain'));
            $grid->addCell($parser->utils->dropdownMenu($ppars));

            parent::onbeforeshowfilelist($pars);
            $this->caption = $parser->utils->getFieldFromSql("SELECT name_".$parser->lang_suff." FROM ".
                        "sys_objects WHERE (objid = '".$parser->pageId."')", '');
        }

        public function import($filename = '')
        {
            global $parser;
            if(!$this->filter_category) return  $parser->gt('choosecategory',  SYS_BASE_PATH.'ext/wproducts');

            $gr = $parser->utils->getFieldFromSql("SELECT c.attrgr FROM wprod_categories c
                                                   WHERE (c.id=".$this->filter_category.")", 0);
            if(!$gr) return $parser->gt('noattrgr', SYS_BASE_PATH.'ext/wproducts');
            $fnames = array();
            $finfo = array();

            $sql = "SELECT DISTINCT f.objid, f.name_".$parser->lang_suff.", f.ref1, f.flt1
                    FROM sys_objects f, sys_objects g, sys_obj_array a
                    WHERE (g.objid='".$gr."')
                    AND (f.objtype='wprod_prodspecs')
                    AND (g.objtype='wprod_prodspecs_gr')
                    AND (a.row_objtype='wprod_prodspecs')
                    AND (a.col_objtype='wprod_prodspecs_gr')
                    AND (f.objid=a.row_objid)
                    AND (g.objid=a.col_objid)
                    ORDER BY f.flt1, f.name_".$parser->lang_suff;

            $rs = $parser->conn->Execute($sql);
            while($row = $rs->FetchRow())
            {
                $fnames[] = mb_strtolower(trim($row[1]), $parser->config['charset']);
                $finfo[] = array('id' => $row[0],
                                'type' => $row[2],
                                'colnum' => -1
                                ) ;
            }

            if(!sizeof($fnames)) return $parser->gt('noattrgr', SYS_BASE_PATH.'ext/wproducts');

            @set_time_limit(0);
            include_once SYS_BASE_PATH.'main/classes/wprototype.class.php';
            $classname = ($this->obj_classname) ? $this->obj_classname : 'wPrototype';

            $this->f = new $classname($this->exp_objtype);
            $a = explode('/',$filename);
            if($a[0] == 'userdata') $filename = SYS_BASE_PATH.$filename;
            if(!file_exists($filename)) return $parser->gt('filenotfound');


            //      
            include_once(SYS_BASE_PATH.'main/classes/wphoto.class.php');
            $foto = new wPhoto();
            //$foto->container = 'wgrid';
            $foto->objtype = 'wprod_products';
            $foto->counter_field = 'photos';
            $foto->mainphoto_field = 'imageid';
            $foto->photoobjtype = 'wprod_products_photo';
            $foto->setObjectFolder('wproducts');

            $grid = new wTablem();
            $grid->objectfolder = $foto->objectfolder;
            $grid->delete_source = false;
            $grid->container = $foto->container;
            $grid->objecturl = SYS_BASE_URL.'userdata/modules/wproducts/'.$foto->photoobjtype;
            $grid->thumbsize = $parser->gs('sys_vars_thumbsize');
            $grid->thumbsize2 = $parser->gs('sys_vars_thumbsizesecond');
            $grid->unzip = false;
            $grid->domark = false;
            $grid->maxwidth = $parser->gs('sys_vars_maximagewidth');
            $grid->photoobjtype = $foto->photoobjtype;
            $grid->objtype = $foto->objtype;
            $grid->counter_field = $foto->counter_field;
            $grid->mainphoto_field = $foto->mainphoto_field;
            include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
            $grid->f = new wPrototype($foto->photoobjtype);
            $grid->f->en_log_insert = false;

            $ext = strtolower(end((explode('.', $filename))));
            $i = 0;
            $this->log = "";
            $this->inserted = 0;
            $this->updated = 0;
            $this->skiped = 0;
            $csv_delimiter = ',';
            $csv_enclosure = '"';

            $id_col = -1;
            $artikul_col = -1;
            $name_col = -1;

            switch($ext)
            {
                case 'csv':

                    ini_set("auto_detect_line_endings", true);
                    $file_handle = fopen($filename, "r");
                    while (!feof($file_handle) )
                    {
                        $line_of_text = fgetcsv($file_handle, 2048, $csv_delimiter, $csv_enclosure);


                        $empty_row = true;
                        if(!$i++)
                        {
                            // Find columns
                            for($k = 0; $k < sizeof($line_of_text); $k++)
                            {
                                $tmpl = mb_strtolower(trim($line_of_text[$k]), $parser->config['charset']);
                                if(strpos($tmpl, "(id)") !== false) $tmpl = 'id';
                                if($tmpl === 'id') $id_col = $k;
                                    elseif($tmpl === $parser->gtl('artikul', SYS_BASE_PATH.'ext/wproducts')) $artikul_col = $k;
                                    elseif($tmpl === $parser->gtl('name', SYS_BASE_PATH.'ext/wproducts')) $name_col = $k;
                                    elseif(in_array($tmpl, $fnames))
                                    {
                                         $finfo[array_search($tmpl, $fnames)]['colnum'] = $k;
                                    }
                                else
                                {
                                    fclose($file_handle);
                                    return  $parser->gt('nofieldsincateg')." - ".$line_of_text[$k];
                                }
                            }
                            if(($id_col < 0) && ($artikul_col < 0) && ($name_col < 0))
                            {
                                fclose($file_handle);
                                return  $parser->gt('nosyncfields', SYS_BASE_PATH.'main/classes');
                            }

                            continue;
                        }
                        for($k = 0; $k < sizeof($line_of_text); $k++)
                        {
                            if(strlen(trim($line_of_text[$k])) and (trim($line_of_text[$k]) != '-'))
                            {
                                $empty_row = false;
                                break;
                            }
                        }
                        if($empty_row)
                        {
                            $this->log .= $i." - ".$parser->gt('emptyrow', SYS_BASE_PATH.'main/classes')."\n";
                            $this->skiped++;
                            continue;
                        }

                        // Check for existing object;
                        $productid = 0;
                        $prodname = '';
                        if($artikul_col) $prodname .= ' '.$line_of_text[$artikul_col];
                        if($name_col) $prodname .= ' '.$line_of_text[$name_col];
                        if($id_col >= 0)
                        {
                            if(trim($line_of_text[$id_col]))
                            $productid = $parser->utils->getFieldFromSql("SELECT id FROM wprod_products
                                WHERE id=".$line_of_text[$id_col], 0);
                        }
                        if(($artikul_col >= 0) && !$productid)
                        {
                            if(trim($line_of_text[$artikul_col]))
                            $productid = $parser->utils->getFieldFromSql("SELECT id FROM wprod_products
                                WHERE artikul='".$parser->conn->escape(trim($line_of_text[$artikul_col]))."' AND artikul<>''", 0);
                        }
                        if(($name_col >= 0) && !$productid)
                        {
                            if(trim($line_of_text[$name_col]))
                            $productid = $parser->utils->getFieldFromSql("SELECT id FROM wprod_products
                                WHERE name_".$parser->lang_suff."='".$parser->conn->escape(trim($line_of_text[$name_col]))."'
                                AND name_".$parser->lang_suff."<>''", 0);
                        }
                        if(!$productid)
                        {
                            $this->log .= $i." - ".$parser->gt('productnotfound').' '.$prodname."\n";
                            $this->skiped++;
                            continue;
                        }

                        //   
                        $parser->conn->Execute("DELETE FROM wprod_products_attr WHERE productid=".$productid);

                        $virgin = true;
                        foreach($finfo as $ft)
                        {
                            if($ft['colnum'] < 0) continue;
                            $val = rtrim($line_of_text[$ft['colnum']]);
                            $f = new wproducts_models_attr();
                            $f->fields->productid->val = $productid;
                            $f->fields->attrtype->val = $ft['id'];

                            switch($ft['type'])
                            {
                                case 'sys_refs_text':
                                case 'sys_refs_string': $f->fields->notes->val = $val; break;
                                case 'sys_refs_float': $f->fields->attrnum->val = $parser->utils->strToFloat($val); break;
                                case 'sys_refs_boolean':
                                    $f->fields->attrnum->val = 0;
                                    if(($val === $parser->gt('yesitis')) ||
                                    ($val == 1) ||
                                    ($val === '+')
                                    ) $f->fields->attrnum->val = 1;
                                break;
                                default:
                                    $a = $this->getrefid($ft['type'], $val);
                                    if($a['mess'])
                                    {
                                        $this->log .= $i." - ".$a['mess']."\n";
                                        $this->skiped++;
                                        continue 2;

                                    }
                                    $f->fields->attrref->val = $a['id'];
                            }
                            $s = $f->insert();
                            if($s)
                            {
                                $this->log .= $i." - ".$s."\n";
                                $this->skiped++;
                                continue 2;
                            } elseif($virgin)
                            {
                                $this->inserted++;
                                $virgin = false;
                            }
                        }
                    }
                    fclose($file_handle);

                    if($this->log) $parser->toFile($this->log, $parser->utils->userdir().'/'.'log.txt');
                    //return '<br />'.$id_col.', '.$artikul_col.', '.$name_col.'<br />'.$finfo[0]['colnum'];
                    //return $sync_txt.'<br />'.$this->inserted.', '.$this->updated.'<br />'.implode(',',$fields_positions);
                    return $parser->gt('importcomplete', SYS_BASE_PATH.'main/classes', $this->inserted, $this->updated, $this->skiped);
                break;
                case 'xls':
                case 'xlsx':
                    include_once(SYS_BASE_PATH.'libs/excel/PHPExcel.php');
                    $inputFileType = PHPExcel_IOFactory::identify($filename);
                    $objReader = PHPExcel_IOFactory::createReader($inputFileType);
                    $objReader->setReadDataOnly(true);

                    $objPHPExcel = $objReader->load($filename);
                    $total_sheets = $objPHPExcel->getSheetCount();
                    $allSheetName = $objPHPExcel->getSheetNames();
                    $objWorksheet = $objPHPExcel->setActiveSheetIndex(0);
                    $highestRow = $objWorksheet->getHighestRow();
                    $highestColumn = $objWorksheet->getHighestColumn();
                    $highestColumnIndex = PHPExcel_Cell::columnIndexFromString($highestColumn);
                    $collabels = array();
                    include_once(SYS_BASE_PATH.'ext/wproducts/models/attr.php');

                    foreach ($this->f->_fields as $key => $value) $collabels[] = $value['label'];
                    for ($row = 1; $row <= $highestRow; ++$row)
                    {

                        $empty_row = true;
                        if(!$i++)
                        {
                            // Find columns
                            for ($col = 0; $col <= $highestColumnIndex; ++$col)
                            {
                                $tmpl = mb_strtolower(trim($objWorksheet->getCellByColumnAndRow($col, $row)->getValue()), $parser->config['charset']);
                                if(strpos($tmpl, "(id)") !== false) $tmpl = 'id';
                                if(!trim($tmpl) || ($tmpl == '-')) continue;
                                if($tmpl === 'id') $id_col = $col;
                                    elseif($tmpl === $parser->gtl('artikul', SYS_BASE_PATH.'ext/wproducts')) $artikul_col = $col;
                                    elseif($tmpl === $parser->gtl('name', SYS_BASE_PATH.'ext/wproducts')) $name_col = $col;
                                    elseif(in_array($tmpl, $fnames))
                                    {
                                         $finfo[array_search($tmpl, $fnames)]['colnum'] = $col;
                                    }
                                else
                                {
                                    $objPHPExcel->disconnectWorksheets();
                                    unset($objPHPExcel);
                                    return  $parser->gt('nofieldsincateg')." - ".$tmpl;
                                }
                            }
                            if(($id_col < 0) && ($artikul_col < 0) && ($name_col < 0))
                            {
                                $objPHPExcel->disconnectWorksheets();
                                unset($objPHPExcel);
                                return  $parser->gt('nosyncfields', SYS_BASE_PATH.'main/classes');
                            }
                            continue;
                        }
                        // Check for existing object;
                        //$parser->toFile(implode(', ',$sync_labels));
                        //break;

                        for ($col = 0; $col <= $highestColumnIndex; ++$col)
                        {
                            $val = $objWorksheet->getCellByColumnAndRow($col, $row)->getValue();
                            if(strlen(trim($val)) and (trim($val) != '-'))
                            {
                                $empty_row = false;
                                break;
                            }
                        }
                        if($empty_row)
                        {
                            $this->log .= $i." - ".$parser->gt('emptyrow', SYS_BASE_PATH.'main/classes')."\n";
                            $this->skiped++;
                            continue;
                        }


                        // Check for existing object;
                        $productid = 0;
                        $prodname = '';
                        if($artikul_col) $prodname .= ' '.$objWorksheet->getCellByColumnAndRow($artikul_col, $row)->getValue();
                        if($name_col) $prodname .= ' '.$objWorksheet->getCellByColumnAndRow($name_col, $row)->getValue();
                        if($id_col >= 0)
                        {
                            $val = trim($objWorksheet->getCellByColumnAndRow($id_col, $row)->getValue());
                            if($val)
                            $productid = $parser->utils->getFieldFromSql("SELECT id FROM wprod_products
                                WHERE id=".$val, 0);
                        }
                        if(($artikul_col >= 0) && !$productid)
                        {
                            $val = trim($objWorksheet->getCellByColumnAndRow($artikul_col, $row)->getValue());
                            if($val)
                            $productid = $parser->utils->getFieldFromSql("SELECT id FROM wprod_products
                                WHERE artikul='".$parser->conn->escape($val)."' AND artikul<>''", 0);
                        }
                        if(($name_col >= 0) && !$productid)
                        {
                            $val = trim($objWorksheet->getCellByColumnAndRow($name_col, $row)->getValue());
                            if($val)
                            $productid = $parser->utils->getFieldFromSql("SELECT id FROM wprod_products
                                WHERE name_".$parser->lang_suff."='".$parser->conn->escape($val)."'
                                AND name_".$parser->lang_suff."<>''", 0);
                        }
                        if(!$productid)
                        {
                            $this->log .= $i." - ".$parser->gt('productnotfound').' '.$prodname."\n";
                            $this->skiped++;
                            continue;
                        }

                        //   
                        $parser->conn->Execute("DELETE FROM wprod_products_attr WHERE productid=".$productid);

                        $virgin = true;
                        foreach($finfo as $ft)
                        {
                            if($ft['colnum'] < 0) continue;
                            $val = rtrim($objWorksheet->getCellByColumnAndRow($ft['colnum'], $row)->getValue());
                            $f = new wproducts_models_attr();
                            $f->en_log_insert = false;
                            $f->fields->productid->val = $productid;
                            $f->fields->attrtype->val = $ft['id'];

                            switch($ft['type'])
                            {
                                case 'sys_refs_text':
                                case 'sys_refs_string': $f->fields->notes->val = $val; break;
                                case 'sys_refs_float': $f->fields->attrnum->val = $parser->utils->strToFloat($val); break;
                                case 'sys_refs_boolean':
                                    $f->fields->attrnum->val = 0;
                                    if(($val === $parser->gt('yesitis')) ||
                                    ($val == 1) ||
                                    ($val === '+')
                                    ) $f->fields->attrnum->val = 1;
                                break;
                                default:
                                    $a = $this->getrefid($ft['type'], $val);
                                    if($a['mess'])
                                    {
                                        $this->log .= $i." - ".$a['mess']."\n";
                                        $this->skiped++;
                                        continue 2;

                                    }
                                    $f->fields->attrref->val = $a['id'];
                            }
                            $s = $f->insert();
                            if($s)
                            {
                                $this->log .= $i." - ".$s."\n";
                                $this->skiped++;
                                continue 2;
                            } elseif($virgin)
                            {
                                $this->inserted++;
                                $virgin = false;
                            }
                        }

                    }

                    $objPHPExcel->disconnectWorksheets();
                    unset($objPHPExcel);

                    if($this->log) $parser->toFile($this->log, $parser->utils->userdir().'/'.'log.txt');
                    //return $sync_txt.'<br />'.$this->inserted.', '.$this->updated.'<br />'.implode(',',$collabels);
                    //return $sync_txt.'<br />'.$this->inserted.', '.$this->updated.'<br />'.implode(',',$fields_positions);
                    return $parser->gt('importcomplete', SYS_BASE_PATH.'main/classes', $this->inserted, $this->updated, $this->skiped).$this->mess;
                break;
            }
        }


    }

    $w = new imradprodimport();
    $w->workframe = 'gridframe';
    $w->startpath = $parser->utils->userdir(false, false).'/';
    $w->exp_objtype = 'wprod_products';
    $w->obj_classname = 'wproducts_models_products';
    $w->filter_category = (isset($_REQUEST['filter_category'])) ? $_REQUEST['filter_category'] : 0;
    $w->filter_prodfields = (isset($_REQUEST['filter_prodfields'])) ? $_REQUEST['filter_prodfields'] : 1;
    $w->filter_charfields = (isset($_REQUEST['filter_charfields'])) ? $_REQUEST['filter_charfields'] : 0;
    $w->filter_manufacter = (isset($_REQUEST['filter_manufacter'])) ? $_REQUEST['filter_manufacter'] : 0;

    $w->addMainMenu0($parser->gt('toexcelcsv', SYS_BASE_PATH.'ext/wproducts'), 'javascript:toexcelcsv');
    $src = "<script type=\"text/javascript\">
    function toexcelcsv(obj)
    {
        filemanager_grid_postAction('exporttocsv', 0);
    }
    </script>";
    $parser->addScript($src);

    $mess = '';
    $form_action = (isset($_REQUEST['form_action'])) ? $_REQUEST['form_action'] : '';
    switch($form_action)
    {
        case 'exporttocsv':
            @set_time_limit(0);
            if(!$w->filter_category)
            {
                $mess =  $parser->gt('choosecategory',  SYS_BASE_PATH.'ext/wproducts');
                break;
            }
            include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
            $grid = new wAjaxGrid();    // path
            $grid->f->objtype = 'wprod_products';
            $grid->f->_setObjType();
            $grid->f->_setFieldsFromSchema(true, true, (($grid->f->moduleid) ? SYS_BASE_PATH.'ext/'.$grid->f->moduleid : __FILE__));

            switch($w->filter_prodfields)
            {
                case 0: //  
                case 2: // 

                    // Make sql with links to external objects
                    //$q = $parser->utils->sql();
                    //$value['size']
                    $lpath = ($grid->f->moduleid) ? SYS_BASE_PATH.'ext/'.$grid->f->moduleid : '';

                    $grid->q->from('wprod_products o');
                    $grid->q->where('o.id<>0');

                    $tables = 0;
                    $fldnum = 0;

                    foreach ($grid->f->_fields as $key => $value)
                    {
                        if(!$value['export'] and ($w->filter_prodfields == 2)) continue;
                        if(!$fldnum and ($value['name'] !== 'id')) $grid->q->select('o.id', 'Id');

                        if(strlen(trim($value['type'])) > 1)
                        {
                            $res = $parser->utils->getObjInfo($value['type']);
                            if(!$res['table']) continue;
                            $grid->q->select('t'.$tables.'.'.$res['namefieldm'].' AS t'.$tables.$res['namefieldm'], $parser->gt($value['label'], $lpath));
                            $grid->q->from($res['table'].' t'.$tables);
                            $grid->q->where('o.'.$value['name'].'=t'.$tables.'.'.$res['keyfield']);
                            $tables++;
                        } else
                        {
                            $name = $value['name'];
                            if($value['lang'])
                            {
                                // Get fieldname without suffix
                                $ta = explode('_', $name);
                                if(sizeof($ta) > 1)
                                {
                                    array_pop($ta);
                                    $name = implode('_', $ta);
                                }
                                $grid->q->lselect('o.'.$name, $parser->gt($value['label'], $lpath));
                            } else $grid->q->select('o.'.$name, $parser->gt($value['label'], $lpath));
                        }
                        $fldnum++;
                    }

                break;
                case 1: //  
                    $grid->q->select('o.id', 'id');
                    $grid->q->select('o.artikul', $parser->gt('artikul'));
                    $grid->q->lselect('o.name', $parser->gt('name'));
                    $grid->q->from('wprod_products o');
                    $grid->q->where('o.id>0');
                break;
            }

            if($w->filter_manufacter)  $grid->q->where("o.manufacter='".$w->filter_manufacter."'");
            //  
            $gr = $parser->utils->getFieldFromSql("SELECT c.attrgr FROM wprod_categories c
                                                   WHERE (c.id=".$w->filter_category.")", 0);
            if(!$gr)
            {
                $mess = $parser->gt('noattrgr', SYS_BASE_PATH.'ext/wproducts');
                break;
            }
            $dop = '';
            if($w->filter_charfields)  $dop = "AND (f.bool1=1) ";
            $sql = "SELECT DISTINCT f.objid, f.name_".$parser->lang_suff.", f.ref1, f.flt1
                    FROM sys_objects f, sys_objects g, sys_obj_array a
                    WHERE (g.objid='".$gr."')
                    AND (f.objtype='wprod_prodspecs')
                    AND (g.objtype='wprod_prodspecs_gr')
                    AND (a.row_objtype='wprod_prodspecs')
                    AND (a.col_objtype='wprod_prodspecs_gr')
                    AND (f.objid=a.row_objid)
                    AND (g.objid=a.col_objid) ".$dop."
                    ORDER BY f.flt1, f.name_".$parser->lang_suff;

            $rs = $parser->conn->Execute($sql);
            $ftablesnum = 0;
            while($row = $rs->FetchRow())
            {
                $ftablesnum++;
                $grid->q->from('wprod_products_attr p'.$ftablesnum);
                $grid->q->where('p'.$ftablesnum.'.productid=o.id');
                $grid->q->where('p'.$ftablesnum.".attrtype='".$row[0]."'");
                switch($row[2])
                {
                    case 'sys_refs_text':
                    case 'sys_refs_string': $grid->q->select('p'.$ftablesnum.'.notes AS strname'.$ftablesnum, $row[1]); break;
                    case 'sys_refs_float': $grid->q->select('p'.$ftablesnum.'.attrnum AS floatname'.$ftablesnum, $row[1]); break;
                    case 'sys_refs_boolean': $grid->q->select("(CASE WHEN p".$ftablesnum.".attrnum=1 THEN '".
                        $parser->gt('yesitis')."' ELSE '".$parser->gt('noitisnot')."' END)  AS boolname".$ftablesnum, $row[1]); break;
                    default:
                        $grid->q->from('sys_objects attrt_'.$ftablesnum);
                        $grid->q->where('p'.$ftablesnum.'.attrref=attrt_'.$ftablesnum.'.objid');
                        $grid->q->lselect('attrt_'.$ftablesnum.'.name AS atrefname'.$ftablesnum, $row[1]);
                }
            }
            //$grid->debug = 1;
            $grid->q->where('o.category='.$w->filter_category);
            $grid->q->orderby('o.id');
            $mess = $grid->exportExcelcsv();
        break;
    }

    $w->show();
    if($mess) print($mess);

?>