<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wprod_rights_lineups');
    if(!$perm['r']) die($parser->gt('not_perms'));
    $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;

    include_once(SYS_BASE_PATH.'main/classes/wcatalog.class.php');
    class wtablecard extends wCatalog
    {
        public $perm = array('c' => 0, 'r' => 0, 'u' => 0, 'd' => 0);
        public function _titleframe()
        {
            global $parser;

            $userid = $parser->getUserId();
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;

            $parent = (isset($_REQUEST['parent'])) ? $_REQUEST['parent'] : 0;

            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';

            $this->addHidden('callbackfunc', $callbackfunc);

            $this->addHidden('parent', $parent);

            $this->f = new wproducts_models_lineups();
            $this->title = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_lineups'", '');

            $this->extra_from = '';
            if($userid !== 'sys_superadmin') $this->extra_where = "";

            $this->addMenu(0, $parser->gt('card'), !$active_tab);
            $this->addMenu(1, $parser->gt('attributetypes'), ($active_tab == 1));
            $this->addMenu(2, $parser->gt('products'), ($active_tab == 2));
            $this->addMenu('main/system/log.php', $parser->gt('log'), ($active_tab === 'main/system/log.php'));
            //$section = $this->addMoreMenuSection($parser->gt('objects'));
            //$this->addMoreMenuSectionItem($section, 'ext/xxx/lib/xxx_xxxlist.php', $parser->gt('xxx'));
        }


        public function _content()
        {
            global $parser;
            $userid = $parser->getUserId();
            $cat_id = (isset($_REQUEST['cat_id'])) ? $_REQUEST['cat_id'] : '';
            $objid = (isset($_REQUEST['objid'])) ? $_REQUEST['objid'] : '';
            $card_onload_par = (isset($_REQUEST['card_onload_par'])) ? $_REQUEST['card_onload_par'] : '';
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : '';
            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';
            if(!$this->adding and !$cat_id) return $parser->gt('no_data_found');

            if(!is_numeric($active_tab) and $active_tab)
            {
                $objtype = 'wprod_lineups';
                $file = SYS_BASE_PATH.$active_tab;
                if(file_exists($file)) include_once($file); else return 'File not found at: '.$file;
            } else
            switch($active_tab)
            {
                case 0:
                    $parser->addScript(SYS_BASE_URL.'main/js/popup.js');

                    $f = new wproducts_models_lineups($this->objtype, $cat_id);
                    $f->id = $cat_id;
                    $f->buttonpanel = 'buttonpanelm';
                    $f->only_card = true;
                    $f->container = 'wprod_lineups_cat';
                    $form_action = (isset($_POST['form_action'])) ? $_POST['form_action'] : '';

                    switch($form_action)
                    {
                        case 'edit':
                            $f->read();
                            $s = $f->update(true);
                            if($s) $f->error_mess = $s;
                            if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                        break;
                        case 'insert':
                            $s = $f->insert(true);
                            if($s) $f->error_mess = $s;
                            else
                            {
                                if($card_onload_par) $f->onCopy($card_onload_par);
                                if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                                return "<SCRIPT LANGUAGE=\"JavaScript\">navigatetoid('".$f->id."');</SCRIPT>";
                            }
                        break;
                    }

                    $f->addHidden('cat_id', $cat_id);
                    $f->addHidden('active_tab', $active_tab);
                    $f->addHidden('callbackfunc', $callbackfunc);
                    $parser->addScript("<script type='text/javascript'>
                    function form_submit()
                    {
                        var btn = document.getElementById('submitbutton');
                        if(btn)
                        {
                            btn.value = '".$parser->gt('loading')."...';
                            btn.disabled = true;
                        }
                        $('#form_dialog_".$f->container."').submit();
                    }
                        </script>");
                    $f->en_autocomplete = true;
                    if($cat_id)
                    {
                        $f->addHidden('form_action', 'edit');
                        $f->addButton($parser->gt('save'), 'form_submit()', 'submitbutton', 'button');
                    } else
                    {
                        if($this->perm['c'])
                        {
                            if($card_onload_par) $f->onBeforeCopy($card_onload_par);

                            $parent = (isset($_REQUEST['parent'])) ? $_REQUEST['parent'] : 0;
                            $f->fields->parent->val = $parent;

                            $f->addHidden('form_action', 'insert');
                            $f->addHidden('card_onload_par', $card_onload_par);
                            $f->addButton($parser->gt('insert'), 'form_submit()', 'submitbutton', 'button');
                            $f->addButton($parser->gt('cancel'), "navigateto('last')", '', 'button');
                        }
                    }

                    return $f->showForm();
                break;
                case 1:
                    if(!$cat_id) die('');
                    //$masterid = $cat_id;
                    //include_once(SYS_BASE_PATH.'ext/....list.php');

                    // Check Rights
                    if(!$parser->getUserId()) die($parser->gt('not_perms'));
                    $perm = $parser->checkPerms('wprod_rights_lineups');
                    if(!$perm['r']) return '<br>'.$parser->gt('not_perms');
                    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
                    $w = new wAjaxGrid();
                    $w->edit_table_alias = 'o';

                    $w->f = new wproducts_models_lineupattr();
                    $w->caption = $parser->gt('attributetypes');

                    $w->q->select('o.id',  $parser->gt('id'));
                    $w->q->lselect('a.name', $parser->gt('name'));
                    $w->q->select('o.sortorder', $parser->gt('sortorder'), array('edit' => $perm['u']));
                    $w->q->from('wprod_lineup_attr o');
                    $w->q->from('sys_objects a');
                    $w->q->where("o.id<>'0'");
                    $w->q->where("o.lineupid='".$cat_id."'");
                    $w->q->where("o.attrid=a.objid");
                    $w->q->orderby('o.id');
                    $w->f->extra_deleteAll_sql .= "AND lineupid='".$cat_id."' ";

                    $w->f->fields->lineupid->val = $cat_id;
                    $w->f->fields->lineupid->refval = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff.' FROM wprod_lineups WHERE id='.$cat_id, '');
                    $w->f->fields->lineupid->ro = true;
                    $w->addingpars = 'lineupid='.$cat_id;

                    $w->addSearchField('o.id', $parser->gt('name'), 'C');

                    $w->editing = $perm['u'];
                    $w->adding = $perm['c'];
                    $w->copying = $perm['c'];
                    $w->deleting = $perm['d'];
                    $w->multiselect = $perm['d'];
                    $w->en_mainmenu = false;


                    //$w->cardurl = $parser->makeUrl('wprod_lineup_attr_card');

                    $w->addHidden('active_tab', $active_tab);
                    $w->addHidden('cat_id', $cat_id);
                    $w->addHidden('callbackfunc', $callbackfunc);
                    $w->show();
                break;
                case 2:
                    if(!$cat_id) die('');
                    //$masterid = $cat_id;
                    //include_once(SYS_BASE_PATH.'ext/....list.php');

                    $action = (isset($_POST['action'])) ? $_POST['action'] : '';
                    switch($action)
                    {
                        case 'additem':
                            $itemid = (isset($_POST['itemid'])) ? $_POST['itemid'] : 0;
                            if(ob_get_length()) ob_clean();
                            if(!$itemid)
                            {
                                print(json_encode(array("mess" => 'error')));
                                exit;
                            }
                            $f = new wproducts_models_products();
                            $f->id = $itemid;
                            $f->read();
                            $f->fields->lineupid->val = $cat_id;
                            $err_mess = $f->update();
                            print(json_encode(array("mess" => $err_mess)));
                            exit;
                        break;
                    }

                    // Check Rights
                    if(!$parser->getUserId()) die($parser->gt('not_perms'));
                    $perm = $parser->checkPerms('wprod_rights_lineups');
                    if(!$perm['r']) return '<br>'.$parser->gt('not_perms');

                    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
                    $w = new wAjaxGrid();
                    $w->edit_table_alias = 'o';

                    $w->f = new wproducts_models_lineupattr();
                    $w->caption = $parser->gt('attributetypes');

                    $w->q->select('o.id',  $parser->gt('id'));
                    $w->q->lselect('o.name', $parser->gt('name'));
                    $w->q->select('o.artikul', $parser->gt('artikul'));
                    $w->q->from('wprod_products o');
                    $w->q->where("o.id<>'0'");
                    $w->q->where("o.lineupid='".$cat_id."'");
                    $w->q->lorderby('o.name');

                    $w->addMainMenu0($parser->gt('catalog'), $action = 'javascript:openCatalog');

                    $src = "<script type=\"text/javascript\">
                    function openCatalog(obj)
                    {
                        openWinc('".$parser->makeUrl('wprod_products_catalog')."', 'onselect=additem');
                    }
                    function additem(itemid)
                    {
                        $.post('index.php',
                        $.param({'pageid':'".$parser->pageId."',
                        'action':'additem',
                        'active_tab':'".$active_tab."',
                        'cat_id':'".$cat_id."',
                        'callbackfunc':'".$callbackfunc."',
                        'itemid':itemid}),
                        function(data)
                        {
                            if(data.mess != '')
                            {
                                //alert(data.mess);
                            } else  global_".$w->container.".loadxml(0);
                        }, 'json');
                    }
                    </script>";
                    $parser->addScript($src);
                    $src = SYS_BASE_URL.'main/js/popup.js';
                    $parser->addScript($src);


                    $w->addSearchField('o.name', $parser->gt('name'), 'C');

                    $w->cardurl = $parser->makeUrl('wprod_products_card');

                    $w->addHidden('active_tab', $active_tab);
                    $w->addHidden('cat_id', $cat_id);
                    $w->addHidden('callbackfunc', $callbackfunc);
                    $w->show();
                break;
            }
        }
    }

    $cat = new wtablecard('wprod_lineups');
    $cat->notreeframe = true;
    $cat->navigation = true;
    $cat->navibuttons = true;
    $cat->extra_from = '';
    $cat->extra_where = '';
    $cat->adding = $perm['c'];
    $cat->deleting = $perm['d'];
    $cat->perm = $perm;

    $cat->showTable(0);


?>