<?php
        // Check Rights
        if(!$parser->getUserId()) die($parser->gt('not_perms'));
        $perm = $parser->checkPerms('wprod_rights_products');
        if(!$perm['r']) die($parser->gt('not_perms'));
        include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
        $w = new wAjaxGrid();
        $filter_period = (isset($_REQUEST['filter_period'])) ? $_REQUEST['filter_period'] : 1;
        $w->f = new wproducts_models_nofound();
        $w->edit_table_alias = 'o';
        //$w->caption = $parser->gt('wprod_nofound', __FILE__);
        $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_nofound'", '');

        $w->q->select('o.id',  $parser->gt('id'));
        $w->q->select('o.createdon', $parser->gt('createdon'));
        $w->q->select('o.userip',  'IP');
        $w->q->select('c.shortname',  $parser->gt('company'));
        $w->q->select('o.searchword', $parser->gt('searchword'));
        $w->q->from('wprod_nofound o');
        $w->q->from('wcrmp_company c');
        $w->q->where("o.companyid=c.id");
        $w->q->orderby('o.id DESC');

        if($filter_period)
        {
             $per = $parser->utils->getPeriod($filter_period, true);
             $w->q->where("o.createdon ".$per);
             $w->f->extra_deleteAll_sql .= "AND (createdon ".$per.")";
        }
        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_period';
        $pars['val'] = $filter_period;
        $w->addCell($parser->utils->periodMenu($pars));

        $w->addSearchField('o.searchword', $parser->gt('searchword'), 'C');
        $w->addSearchField('o.userip', 'IP', 'C');
        $w->addSearchField('o.companyid', $parser->gt('company'), 'wcrmp_company');

        $w->editing = false;
        $w->adding = false;
        $w->copying = false;
        $w->deleting = $perm['d'];
        $w->multiselect = $perm['d'];



        $w->show();
?>