<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wprod_rights_products');
    if(!$perm['r']) die($parser->gt('not_perms'));
    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
    $w = new wAjaxGrid();

    $w->f = new wproducts_models_photo;
    $w->f->en_delete_all = true;
    $w->edit_table_alias = 'o';
    //$w->caption = $parser->gt('wprod_lineups', __FILE__); sortorder
    $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_products_photo'", '');

    $w->q->select('o.id',  $parser->gt('id'));
    $w->q->select("'' AS FOTO", $parser->gt('photo'), array('calc' => 'show_image_at_cell', 'html' => true));

    $w->q->select('p.artikul', $parser->gt('artikul'));
    $compn_col = $w->q->lselect('p.name', $parser->gt('name'));
    $w->q->select('o.notes',  $parser->gt('notes'), array('edit' => $perm['u']));
    $w->q->select('o.creaton', $parser->gt('creaton'));
    $comid_col = $w->q->select('o.masterid', $parser->gt('id'), array('hide' => true));
    $w->q->select('o.filetype', $parser->gt('type'), array('hide' => true));

    $w->q->from('wprod_products_photo o');
    $w->q->from('wprod_products p');
    $w->q->where("o.masterid=p.id");
    $w->q->where("o.id>0");
    $w->q->orderby('o.id');

    //$w->addSearchField('o.name', $parser->gt('name'), 'C');
    //$w->addSearchField('o.notes', $parser->gt('notes'), 'C');

    $w->editing = false;
    $w->adding = false;
    $w->copying = false;
    $w->deleting = $perm['d'];
    $w->multiselect = $perm['d'];


    //$w->cardurl = $parser->makeUrl('wprod_lineups_card');
    $w->addCard($compn_col, $comid_col, $parser->makeUrl('wprod_products_card'));

    if(!function_exists('show_image_at_cell'))
    {
        function show_image_at_cell($rs,$i,$v,$this)
        {
            global $parser;
            $imext = (trim($rs->fields[7])) ? $rs->fields[7] : 'jpg';
            $ico = SYS_BASE_URL."userdata/modules/wproducts/wprod_products_photo/icons/".$rs->fields[0].".".$imext;
            return "<img src=\"".$ico."\" width=\"32\" />";
        }

    }

    $w->show();




?>