<?php
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wprod_rights_products');
    if(!$perm['r']) die($parser->gt('not_perms'));
    $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;

    //$unload = ($callbackfunc) ? " onunload=\"".$callbackfunc."\"" : '';

    include_once(SYS_BASE_PATH.'main/classes/wcatalog.class.php');
    class wtablecard extends wCatalog
    {
        public $perm = array('c' => 0, 'r' => 0, 'u' => 0, 'd' => 0);
        public function _titleframe()
        {
            global $parser;
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;
            $category = (isset($_REQUEST['category'])) ? $_REQUEST['category'] : 0;
            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';

            $this->addHidden('callbackfunc', $callbackfunc);
            $this->addHidden('category', $category);
            $this->title = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_products'", '');

            $this->f = new wproducts_models_products();

            $this->addMenu(0, $parser->gt('card'), !$active_tab);
            $this->addMenu(1, $parser->gt('properties'), ($active_tab == 1));
            $this->addMenu(2, $parser->gt('features'), ($active_tab == 2));
            $this->addMenu(3, $parser->gt('photo'), ($active_tab == 3));
            $this->addMenu(4, $parser->gt('files'), ($active_tab == 4));
            $this->extra_from = '';
            $this->extra_where = '';
        }

        public function _titleframeWithId($id = 0)
        {
            global $parser;
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;
            if(!$id) return '';
            $prodtype = $parser->utils->getFieldFromSql('SELECT prodtype FROM wprod_products WHERE id='.$id, '');

            $this->addMoreMenu();
            if($prodtype === 'wprod_prodtypes_file') $this->addMoreMenuItem('ext/wproducts/lib/files_roles.php', $parser->gt('roles'));
            if($parser->checkPerms('wprod_rights_reviews', 'r'))
            $this->addMoreMenuItem(5, $parser->gt('mcomments'));
            $this->addMoreMenuItem('ext/wproducts/lib/reviewslist.php', $parser->gt('reviews'));
            $section = $this->addMoreMenuSection($parser->gt('realestate'));
            $this->addMoreMenuSectionItem($section, 'ext/wproducts/lib/rateslist.php', $parser->gt('rates'));
            $this->addMoreMenuSectionItem($section, 'ext/wproducts/lib/ratescalendar.php', $parser->gt('rates').' - '.$parser->gt('calendar'));
            $this->addMoreMenuSectionItem($section, 'ext/wproducts/lib/bookinglist.php', $parser->gt('booking'));
            $this->addMoreMenuSectionItem($section, 'ext/wproducts/lib/bookingcalendar.php', $parser->gt('booking').' - '.$parser->gt('calendar'));

            $this->addMoreMenuItem('ext/wproducts/lib/productstagslist.php', $parser->gt('tags'));
            $this->addMoreMenuItem('ext/wproducts/lib/productslanglist.php', $parser->gt('localization'));
            $this->addMoreMenuItem('main/system/log.php', $parser->gt('log'));
        }

        public function _navigation()
        {
            global $parser;
            $cat_id = (isset($_REQUEST['cat_id'])) ? $_REQUEST['cat_id'] : '';
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;
            switch($active_tab)
            {
                case 1: // Properties
                    $start_prop = (isset($_REQUEST['start_prop'])) ? $_REQUEST['start_prop'] : 'wprod_obj_prop_products';

                    include_once(SYS_BASE_PATH.'main/classes/wajaxtree.class.php');
                    $tree = new wAjaxTree();
                    $tree->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='".$start_prop."'", '');
                    include_once(SYS_BASE_PATH.'main/objects/objtypes.class.php');
                    $tree->f = new wObjtypes();
                    $tree->edit_keyfield = 'objtype';

                    $tree->startfrom = $start_prop;
                    $tree->q->select('objtype');
                    $tree->q->select('name', '', array('lang' => true));
                    $tree->q->select('isfolder');
                    $tree->q->select('parent');
                    $tree->q->from('sys_objtypes');
                    $tree->q->where("objtype<>'0'");
                    $tree->q->where("parent=:parent:");
                    $tree->q->lorderby('name');

                    $tree->editing = true;
                    $tree->adding = true;
                    $tree->deleting = true;

                    $tree->addHidden('cat_id', $cat_id);
                    $tree->addHidden('start_prop', $start_prop);
                    $tree->addHidden('active_tab', $active_tab);
                    $tree->leaf_func = 'leafclickm';
                    $tree->folder_func = 'leafclickm';
                    //$tree->unselect = true;

                    $src = "<script type=\"text/javascript\">
                    function leafclickm(id, treetype)
                    {
                        $.post('index.php',
                        $.param({'pageid':'sys_utils_propinfo',
                        'action':'getpropinfo',
                        'proptype':id}),
                        function(data)
                        {
                            try
                            {
                                global_ajaxgrid.setProperty('colnames', data.colnames);
                                reloadgrid(id, treetype);
                            } catch(e) {}
                        }, 'json');
                    }
                    ";
                    $src .= $this->_script;
                    $src .= "</script>\n";
                    $parser->addScript($src);
                    $tree->show();
                break;
            }

            return '';
        }

        public function _content()
        {
            global $parser;
            $cat_id = (isset($_REQUEST['cat_id'])) ? $_REQUEST['cat_id'] : '';
            $objid = (isset($_REQUEST['objid'])) ? $_REQUEST['objid'] : '';
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;
            $card_onload_par = (isset($_REQUEST['card_onload_par'])) ? $_REQUEST['card_onload_par'] : '';
            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';
            $action = (isset($_REQUEST['action'])) ? $_REQUEST['action'] : '';
            $formid = (isset($_REQUEST['formid'])) ? $_REQUEST['formid'] : 0;
            if(!$this->adding and !$cat_id) return $parser->gt('no_data_found');
            $output = '';
            if(!is_numeric($active_tab) and $active_tab)
            {
                $objtype = 'wprod_products';
                $objid = $cat_id;
                $productid = $cat_id;
                $master_productid = $cat_id;
                $file = SYS_BASE_PATH.$active_tab;
                if(file_exists($file)) include_once($file); else return 'File not found at: '.$file;
            } else
            switch($active_tab)
            {
                case 0:
                    $parser->addScript(SYS_BASE_URL.'main/js/popup.js');
                    $f = new wproducts_models_products($this->objtype, $cat_id);
                    $f->buttonpanel = 'buttonpanelm';
                    $f->id = $cat_id;
                    $f->only_card = true;
                    $f->container = 'wprod_products_cat';
                    $form_action = (isset($_POST['form_action'])) ? $_POST['form_action'] : '';
                    switch($form_action)
                    {
                        case 'edit':
                            $f->read();
                            $s = $f->update(true);
                            if($s) print($s);
                            if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                        break;
                        case 'insert':
                            $s = $f->insert(true);
                            if($s)
                            {
                                $f->error_mess = $s;
                            }
                            else
                            {
                                if($card_onload_par) $f->onCopy($card_onload_par);
                                if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                                return "<SCRIPT LANGUAGE=\"JavaScript\">navigatetoid('".$f->id."');</SCRIPT>";
                            }
                        break;
                    }

                    $f->addHidden('callbackfunc', $callbackfunc);
                    $f->addHidden('cat_id', $cat_id);
                    $f->addHidden('active_tab', $active_tab);
                    $parser->addScript("<script type='text/javascript'>
                    function form_submit()
                    {
                        var btn = document.getElementById('submitbutton');
                        if(btn)
                        {
                            btn.value = '".$parser->gt('loading')."...';
                            btn.disabled = true;
                        }
                        $('#form_dialog_".$f->container."').submit();
                    }
                    </script>");
                    $f->en_autocomplete = true;
                    if($cat_id)
                    {
                        if($this->perm['u'])
                        {
                            $f->addHidden('form_action', 'edit');
                            $f->addButton($parser->gt('save'), 'form_submit()', 'submitbutton', 'button');
                        }
                    } else
                    {
                        if($this->perm['c'])
                        {
                            if($card_onload_par) $f->onBeforeCopy($card_onload_par);
                            $category = (isset($_REQUEST['category'])) ? $_REQUEST['category'] : 0;
                            $f->setFieldVal('category', $category);
                            $f->addHidden('form_action', 'insert');
                            $f->addHidden('action', 'title_adding');
                            $f->addButton($parser->gt('insert'), 'form_submit()', 'submitbutton', 'button');
                            $f->addButton($parser->gt('cancel'), "navigateto('last')", '', 'button');
                        }
                    }

                    return $f->showForm();
                break;
                case 1: // Properties
                    $subcat_id = (isset($_REQUEST['subcat_id'])) ? $_REQUEST['subcat_id'] : '';

                    include_once(SYS_BASE_PATH.'main/objects/props.class.php');
                    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
                    $grid = new wAjaxGrid();
                    $grid->visible = false;
                    $grid->f = new wProps($subcat_id);
                    $grid->f->setFieldVal('masterid', $cat_id);
                    $grid->f->setFieldVal('proptype', $subcat_id);
                    $grid->q = $grid->f->sql_object;
                    $grid->q->where('d.masterid='.$cat_id);
                    $grid->q->where("d.proptype='".$subcat_id."'");
                    $grid->edit_table_alias = 'd';
                    //$grid->f->setFieldAttr('masterid', 'refval', $parser->utils->getFieldFromSql('SELECT shortname FROM wcomm_company WHERE id='.$company, ''));
                    $grid->f->setFieldAttr('masterid', 'hide', true);

                    $grid->adding = true;
                    $grid->editing = true;
                    $grid->deleting = true;
                    $grid->multiselect = 1;

                    $grid->addHidden('subcat_id', $subcat_id);
                    $grid->addHidden('cat_id', $cat_id);
                    $grid->addHidden('active_tab', $active_tab);
                    $grid->addHidden('callbackfunc', $callbackfunc);
                    $grid->caption = $parser->utils->getFieldFromSql("SELECT name_".$parser->lang_suff." FROM sys_objtypes WHERE objtype='".$subcat_id."'", '');
                    //$grid->debug = true;
                    $grid->show();

                    return '';
                break;
                case 2:
                    if(!$cat_id) die('');
                    //$masterid = $cat_id;
                    //include_once(SYS_BASE_PATH.'ext/....list.php');

                    include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
                    $field = new wPrototype('wprod_products_attr');
                    $field->en_log_update = false;
                    $field->en_log_insert = false;
                    $field->en_log_delete = false;
                    $src = "<script type=\"text/javascript\">\n";
                    $src .= $field->getPopupScript()."\n</script>\n";
                    $parser->addScript($src);


                    if(!$cat_id) return $parser->gt('no_data_found');
                    $gr = $parser->utils->getFieldFromSql("SELECT c.attrgr FROM wprod_products p, wprod_categories c
                                                           WHERE (p.id=".$cat_id.")
                                                           AND (p.category=c.id)", 0);
                    if(!$gr) return ' '.$parser->gt('noattrgr');
                    $sql = "SELECT DISTINCT f.objid, f.name_".$parser->lang_suff.", f.ref1, f.flt1
                            FROM sys_objects f, sys_objects g, sys_obj_array a
                            WHERE (g.objid='".$gr."')
                            AND (f.objtype='wprod_prodspecs')
                            AND (g.objtype='wprod_prodspecs_gr')
                            AND (a.row_objtype='wprod_prodspecs')
                            AND (a.col_objtype='wprod_prodspecs_gr')
                            AND (f.objid=a.row_objid)
                            AND (g.objid=a.col_objid)
                            ORDER BY f.flt1, f.name_".$parser->lang_suff;
                    //print($sql);
                    switch($action)
                    {
                        case 'addattr':
                            $rs = $parser->conn->Execute($sql);
                            while($row = $rs->FetchRow())
                            {
                                $val = (isset($_POST['_val_'.$row[0]])) ? $_POST['_val_'.$row[0]] : 0;
                                $ref = $num = 0;
                                if(($row[2] == 'sys_refs_boolean') or ($row[2] == 'sys_refs_float')) $num = $val; else $ref = $val;

                                $id = $parser->utils->getFieldFromSql("SELECT id
                                                                       FROM wprod_products_attr
                                                                       WHERE (attrtype='".$row[0]."')
                                                                       AND (productid=".$cat_id.")",0);
                                if($id)
                                {
                                    $field->id = $id;
                                    $field->read();
                                }

                                $field->setFieldNewVal('productid', $cat_id);
                                $field->setFieldNewVal('attrtype', $row[0]);
                                $field->setFieldNewVal('attrref', $ref);
                                $field->setFieldNewVal('attrnum', $num);
                                $field->setFieldNewVal('notes', (isset($_POST['_notes_'.$row[0]])) ? $_POST['_notes_'.$row[0]] : '');
                                if($id) $s = $field->update();
                                    else
                                    {
                                        $field->id =0;
                                        $field->fields->id->val = 0;
                                        $s = $field->insert();
                                    }
                                if($s) print($s);
                            }
                        break;
                    }

                    print("<form method=\"POST\" action=\"".$parser->makeUrl($parser->pageId)."\">\n");
                    print("<div class=\"buttonpanelm\">");
                    print("<input type=\"submit\" value=\"".$parser->gt('save')."\" class=\"button\" />");
                    print("<input type=\"hidden\" value=\"".$cat_id."\" name=\"cat_id\" />");
                    print("<input type=\"hidden\" value=\"".$active_tab."\" name=\"active_tab\" />");
                    print("<input type=\"hidden\" value=\"addattr\" name=\"action\" />");
                    print("<input type=\"hidden\" value=\"".$formid."\" name=\"formid\" />");
                    print("</div>");

                    print('<h3>'.$parser->gt('features').' '.$parser->utils->getFieldFromSql("SELECT name_".$parser->lang_suff." FROM wprod_products WHERE id=".$cat_id, '').'</h3>');
                    $rs = $parser->conn->Execute($sql);
                    if($rs->NumRows() <= 0) return '';
                    $output = '';
                    $i = 0;
                    $output .= "<table class=\"listtable\">\n";
                    $output .= "<tr class=\"headercol\">\n";
                    $output .= "<td>".$parser->gt('name')."</td>\n";
                    $output .= "<td>".$parser->gt('value')."</td>\n";
                    $output .= "<td>".$parser->gt('notes')."</td>\n";
                    $output .= "</tr>\n";

                    while($row = $rs->FetchRow())
                    {
                        $output .= "<tr class=\"".(($i % 2) ? 'listeven' : 'listodd')."\">\n";
                        $output .= "<td>".$row[1]."</td>\n";
                        $ar = $parser->utils->getFieldsFromSql("SELECT p.attrnum, p.attrref, p.notes, c.name_".$parser->lang_suff."
                                                               FROM wprod_products_attr p, sys_objects c
                                                               WHERE (p.attrtype='".$row[0]."')
                                                               AND (p.productid=".$cat_id.")
                                                               AND (p.attrref=c.objid)", array(0,'0','',''), 'num');

                        if($row[2] and ($row[2] != 'sys_refs_text') and ($row[2] != 'sys_refs_string'))
                        {
                            $output .= "<td>";
                            $val = $ar[1];
                            if(($row[2] == 'sys_refs_boolean') or ($row[2] == 'sys_refs_float')) $val = $ar[0];
                            $pars = array('label' => '',
                                          'name' => '_val_'.$row[0],
                                          'val' => $val,
                                          'rows' => 3,
                                          'refval' => $ar[3],
                                          'type' => $row[2],
                                          'table_row' => 0,
                                          'table_cell' => 0,
                                          'width' => 200
                                        );
                            $output .=  $field->formField($pars);
                            $output .= "</td>\n";
                            $output .= "<td><textarea name=\"_notes_".$row[0]."\" rows=\"1\" cols=\"50\" class=\"txt_script\">".$ar[2]."</textarea></td>\n";
                        } else
                        {
                            $output .= "<td colspan=\"2\"><textarea name=\"_notes_".$row[0]."\" rows=\"3\" cols=\"50\" class=\"txt_script\">".$ar[2]."</textarea></td>\n";
                        }
                        $output .= "</tr>\n";
                        $i++;
                    }
                    $output .= "</table>\n";
                    print($output);
                    print("</form>");
                break;
                case 3:
                    if(!$cat_id) return $parser->gt('no_data_found');
                    include_once(SYS_BASE_PATH.'main/classes/wphoto.class.php');
                    $foto = new wPhoto();
                    //$foto->container = 'wgrid';
                    $foto->objtype = 'wprod_products';
                    $foto->counter_field = 'photos';
                    $foto->mainphoto_field = 'imageid';
                    $foto->objid = $cat_id;
                    $foto->photoobjtype = 'wprod_products_photo';
                    $foto->show_icon2 = true;

                    $foto->adding = true;
                    $foto->editing = true;
                    $foto->deleting = true;

                    $foto->iconw = $parser->gs('wprod_setting_iconw');
                    $foto->iconw2 = $parser->gs('wprod_setting_iconw2');
                    $foto->imagew = $parser->gs('wprod_setting_photow');

                    $foto->addHidden('cat_id', $cat_id);
                    $foto->addHidden('active_tab', $active_tab);
                    $foto->addHidden('callbackfunc', $callbackfunc);
                    $foto->show();
                break;
                case 4:
                    if(!$cat_id) die('');
                    include_once(SYS_BASE_PATH.'main/utils/fileman.class.php');
                    $w = new wcat();
                    $w->workframe = 'gridframe';
                    $w->cat_id = $cat_id;
                    $w->active_tab = $active_tab;

                    $w->objtype = 'wprod_products';
                    $w->startpath_org = 'userdata/modules/wproducts/wprod_products';
                    $w->startpath = $w->startpath_org.'/';
                    $w->autocreatedir = 1;
                    $w->execute_menu  = $parser->isSuperAdmin();
                    $w->show();
                break;
                case 5: // comments
                    if(!$cat_id) die('');
                    $perm = $parser->checkPerms('wprod_rights_products');
                    if(!$perm['r']) return '<br>'.$parser->gt('not_perms');
                    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
                    $w = new wAjaxGrid();
                    $w->edit_table_alias = 'o';

                    $w->caption = $parser->gt('mcomments');

                    $w->q->select('o.id',  $parser->gt('id'));
                    $w->q->select('o.createdon', $parser->gt('createdon'));
                    $w->q->select('o.username', $parser->gt('user'));
                    $w->q->select('o.userip', 'IP');
                    $w->q->select('o.comments', $parser->gt('comment'));
                    $w->q->from('wprod_comments o');
                    $w->q->where("o.id<>'0'");
                    $w->q->where("o.masterid='".$cat_id."'");
                    $w->q->orderby('o.username');
                    $w->f->extra_deleteAll_sql .= "AND masterid='".$cat_id."' ";

                    $w->addSearchField('o.comments', $parser->gt('comment'), 'C');

                    $w->editing = false;
                    $w->adding = false;
                    $w->copying = false;
                    $w->deleting = $perm['d'];
                    $w->multiselect = $perm['d'];
                    $w->en_mainmenu = false;


                    //$w->cardurl = $parser->makeUrl('wprod_rcomments_card');

                    $w->addHidden('active_tab', $active_tab);
                    $w->addHidden('cat_id', $cat_id);
                    $w->addHidden('callbackfunc', $callbackfunc);
                    $w->show();
                break;
            }
        }

    }

    $cat = new wtablecard('wprod_products');
    $cat->notreeframe = true;
    $cat->navigation = true;
    $cat->navibuttons = true;
    $cat->extra_from = '';
    $cat->extra_where = '';
    $cat->adding = $perm['c'];
    $cat->deleting = $perm['d'];
    $cat->perm = $perm;

    $width = 0;
    switch($active_tab)
    {
        case 1: $width = 25; break;
    }
    $cat->showTable($width);

?>