<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wprod_rights_products');
    if(!$perm['r']) die($parser->gt('not_perms'));
    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
    $w = new wAjaxGrid();
    $filter_productid = (isset($_REQUEST['filter_productid'])) ? $_REQUEST['filter_productid'] : '';
    $filter_period = (isset($_REQUEST['filter_period'])) ? $_REQUEST['filter_period'] : 1;

    $active_tab =  (isset($active_tab)) ? $active_tab : '0';
    $cat_id =  (isset($cat_id)) ? $cat_id : '0';
    $callbackfunc =  (isset($callbackfunc)) ? $callbackfunc : '';

    if($cat_id)
    {
        $filter_productid = $cat_id;
        $filter_period = 0;
    }

    $prod_col = 0;
    $prodid_col = 0;
    $w->f = new wproducts_models_rates();
    $w->edit_table_alias = 'o';
    //$w->caption = $parser->gt('wprod_rates', __FILE__);
    $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_rates'", '');

    $w->q->select('o.id',  $parser->gt('id'));
    if(!$cat_id) $prod_col = $w->q->lselect('p.name', $parser->gt('product'));
    $w->q->select('o.starton', $parser->gt('fromdate'));
    $w->q->select('o.finishon', $parser->gt('todate'));
    $w->q->select('o.taxprice', $parser->gt('price'));
    $w->q->from('wprod_rates o');
    $w->q->where("o.id<>'0'");
    $w->q->orderby('o.id');

    if(!$cat_id)
    {
        $prodid_col = $w->q->select('o.productid',  $parser->gt('productid'), array('hide' =>true));
        $w->q->from('wprod_products p');
        $w->q->where("o.productid=p.id");
    }
    if($filter_period)
    {
         $per = $parser->utils->getPeriod($filter_period, true);
         $w->q->where("o.starton ".$per);
         $w->f->extra_deleteAll_sql .= "AND (starton ".$per.")";
    }
    if($filter_productid)
    {
        $mfilter_productid = $parser->utils->addQuots($filter_productid);
        $w->q->where("o.productid IN(".$mfilter_productid.")");
        $w->f->extra_deleteAll_sql .= "AND productid IN(".$mfilter_productid.") ";
        $w->f->fields->productid->val = $filter_productid;
    }
    $pars = array();
    $pars['onchange'] = $w->container."_postAction('',0)";
    $pars['name'] = 'filter_period';
    $pars['val'] = $filter_period;
    $w->addCell($parser->utils->periodMenu($pars));

    if(!$cat_id)
    {
        $w->popup_script = true;
        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_productid';
        $pars['emptyval'] = 0;
        $pars['tree_btn'] = 0;
        $pars['emptyrefval'] = $parser->gt('allproducts');
        $pars['val'] = $filter_productid;
        $pars['objtype'] = 'wprod_products';
        $pars['extra_pars'] = " AND (prodtype='wprod_prodtypes_estate') ";
        $w->addCell($parser->utils->finder($pars));
    }
    $w->addSearchField('o.id', $parser->gt('name'), 'C');

    $w->editing = $perm['u'];
    $w->adding = $perm['c'];
    $w->copying = $perm['c'];
    $w->deleting = $perm['d'];
    $w->multiselect = $perm['d'];

    $w->addHidden('active_tab', $active_tab);
    $w->addHidden('cat_id', $cat_id);
    $w->addHidden('callbackfunc', $callbackfunc);

    if($perm['c'])
    {
        $w->addMainMenu0($parser->gt('import', SYS_BASE_PATH.'main/objects'), 'javascript:dataimport');
    	$src = SYS_BASE_URL.'main/js/popup.js';
        $parser->addScript($src);
        $src = "
        <script type='text/javascript'>
        function dataimport(obj)
        {
            openWinc('".$parser->makeUrl('sys_admin_utils_import')."', 'callbackfunc=self.opener.global_".$w->container.".loadxml(0)&exp_objtype=wprod_rates');
        }
        </script>
        ";
        $parser->addScript($src);
    }

    if(!$cat_id) $w->addCard($prod_col, $prodid_col, $parser->makeUrl('wprod_products_card'));

    $w->show();
?>