<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wprod_rights_reviews');
    if(!$perm['r']) die($parser->gt('not_perms'));
    $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;

    include_once(SYS_BASE_PATH.'main/classes/wcatalog.class.php');
    class wtablecard extends wCatalog
    {
        public $perm = array('c' => 0, 'r' => 0, 'u' => 0, 'd' => 0);
        public function _titleframe()
        {
            global $parser;

            $userid = $parser->getUserId();
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;
            $productid = (isset($_REQUEST['productid'])) ? $_REQUEST['productid'] : '';
            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';

            $this->addHidden('callbackfunc', $callbackfunc);
            $this->addHidden('productid', $productid);

            $this->f = new wproducts_models_reviews();
            $this->title = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_reviews'", '');

            $this->extra_from = '';
            if($userid !== 'sys_superadmin') $this->extra_where = "";

            $this->addMenu(0, $parser->gt('card'), !$active_tab);
            $this->addMenu(1, $parser->gt('mcomments'), ($active_tab == 1));
            $this->addMenu(2, $parser->gt('files'), ($active_tab == 2));
            $this->addMenu('main/system/log.php', $parser->gt('log'), ($active_tab === 'main/system/log.php'));
            //$section = $this->addMoreMenuSection($parser->gt('objects'));
            //$this->addMoreMenuSectionItem($section, 'ext/xxx/lib/xxx_xxxlist.php', $parser->gt('xxx'));
        }


        public function _content()
        {
            global $parser;
            $userid = $parser->getUserId();
            $cat_id = (isset($_REQUEST['cat_id'])) ? $_REQUEST['cat_id'] : '';
            $objid = (isset($_REQUEST['objid'])) ? $_REQUEST['objid'] : '';
            $card_onload_par = (isset($_REQUEST['card_onload_par'])) ? $_REQUEST['card_onload_par'] : '';
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : '';
            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';
            if(!$this->adding and !$cat_id) return $parser->gt('no_data_found');

            if(!is_numeric($active_tab) and $active_tab)
            {
                $objtype = 'wprod_reviews';
                $file = SYS_BASE_PATH.$active_tab;
                if(file_exists($file)) include_once($file); else return 'File not found at: '.$file;
            } else
            switch($active_tab)
            {
                case 0:
                    $parser->addScript(SYS_BASE_URL.'main/js/popup.js');

                    $f = new wproducts_models_reviews($this->objtype, $cat_id);
                    $f->id = $cat_id;
                    $f->buttonpanel = 'buttonpanelm';
                    $f->only_card = true;
                    $f->container = 'wprod_reviews_cat';
                    $form_action = (isset($_POST['form_action'])) ? $_POST['form_action'] : '';

                    switch($form_action)
                    {
                        case 'edit':
                            $f->read();
                            $s = $f->update(true);
                            if($s) $f->error_mess = $s;
                            if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                        break;
                        case 'insert':
                            $s = $f->insert(true);
                            if($s) $f->error_mess = $s;
                            else
                            {
                                if($card_onload_par) $f->onCopy($card_onload_par);
                                if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                                return "<SCRIPT LANGUAGE=\"JavaScript\">navigatetoid('".$f->id."');</SCRIPT>";
                            }
                        break;
                    }

                    $f->addHidden('cat_id', $cat_id);
                    $f->addHidden('active_tab', $active_tab);
                    $f->addHidden('callbackfunc', $callbackfunc);
                    $parser->addScript("<script type='text/javascript'>
                    function form_submit()
                    {
                        $('#form_dialog_".$f->container."').submit();
                    }
                        </script>");
                    $f->en_autocomplete = true;
                    if($cat_id)
                    {
                        $f->addHidden('form_action', 'edit');
                        $f->addButton($parser->gt('save'), 'form_submit()', 'submitbutton', 'button');
                    } else
                    {
                        if($this->perm['c'])
                        {
                            if($card_onload_par) $f->onBeforeCopy($card_onload_par);
                            $productid = (isset($_REQUEST['productid'])) ? $_REQUEST['productid'] : '';
                            if($productid)
                            {
                                $f->setFieldVal('productid', $productid);
                                $f->setFieldAttr('productid', 'refval', $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff.' FROM wprod_products WHERE id='.$productid, ''));
                                $f->setFieldAttr('productid', 'ro', true);
                            }

                            $f->addHidden('form_action', 'insert');
                            $f->addHidden('card_onload_par', $card_onload_par);
                            $f->addButton($parser->gt('insert'), 'form_submit()', 'submitbutton', 'button');
                            $f->addButton($parser->gt('cancel'), "navigateto('last')", '', 'button');
                        }
                    }

                    return $f->showForm();
                break;
                case 1:
                    if(!$cat_id) die('');
                    $perm = $parser->checkPerms('wprod_rights_reviews');
                    if(!$perm['r']) return '<br>'.$parser->gt('not_perms');
                    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
                    $w = new wAjaxGrid();
                    $w->edit_table_alias = 'o';

                    $w->f = new wproducts_models_rcomments();
                    $w->caption = $parser->gt('mcomments');

                    $w->q->select('o.id',  $parser->gt('id'));
                    $w->q->select('o.createdon', $parser->gt('createdon'));
                    $w->q->select('o.username', $parser->gt('user'));
                    $w->q->select('o.userip', 'IP');
                    $w->q->select('o.comments', $parser->gt('comment'));
                    $w->q->from('wprod_rcomments o');
                    $w->q->where("o.id<>'0'");
                    $w->q->where("o.masterid='".$cat_id."'");
                    $w->q->orderby('o.username');
                    $w->f->extra_deleteAll_sql .= "AND masterid='".$cat_id."' ";

                    $w->f->fields->masterid->val = $cat_id;
                    $w->f->fields->masterid->refval = $parser->utils->getFieldFromSql('SELECT title FROM wprod_reviews WHERE id='.$cat_id, '');
                    $w->f->fields->masterid->ro = true;
                    $w->addingpars = 'masterid='.$cat_id;

                    $w->addSearchField('o.comments', $parser->gt('comment'), 'C');

                    $w->editing = $perm['u'];
                    $w->adding = false;
                    $w->copying = false;
                    $w->deleting = $perm['d'];
                    $w->multiselect = $perm['d'];
                    $w->en_mainmenu = false;


                    //$w->cardurl = $parser->makeUrl('wprod_rcomments_card');

                    $w->addHidden('active_tab', $active_tab);
                    $w->addHidden('cat_id', $cat_id);
                    $w->addHidden('callbackfunc', $callbackfunc);
                    $w->show();
                break;
                case 2: // files
                    if(!$cat_id) return '';
                    include_once(SYS_BASE_PATH.'main/utils/fileman.class.php');
                    $w = new wcat();
                    $w->workframe = 'gridframe';
                    $w->cat_id = $cat_id;
                    $w->active_tab = $active_tab;
                    $w->objtype = 'wprod_reviews';
                    $w->startpath_org = 'userdata/modules/wproducts/wprod_reviews';
                    $w->startpath = $w->startpath_org.'/';
                    $w->autocreatedir = 1;
                    $w->execute_menu  = $parser->isSuperAdmin();
                    $w->show();
                break;

            }
        }
    }

    $cat = new wtablecard('wprod_reviews');
    $cat->notreeframe = true;
    $cat->navigation = true;
    $cat->navibuttons = true;
    $cat->extra_from = '';
    $cat->extra_where = '';
    $cat->adding = $perm['c'];
    $cat->deleting = $perm['d'];
    $cat->perm = $perm;

    $cat->showTable(0);


?>