<?php
        // Check Rights
        if(!$parser->getUserId()) die($parser->gt('not_perms'));
        $perm = $parser->checkPerms('wprod_rights_prodcats');
        if(!$perm['r']) die($parser->gt('not_perms'));
        include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
        $w = new wAjaxGrid();
        $w->f = new wproducts_models_categories();
        $w->edit_table_alias = 'o';
        //$w->caption = $parser->gt('wprod_categories', __FILE__);
        $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_categories'", '');
        //$w->en_mainmenu = false;
        if($perm['c'])
        {
            $w->addMainMenu0($parser->gt('import', SYS_BASE_PATH.'main/objects'), 'javascript:dataimport');
        	$src = SYS_BASE_URL.'main/js/popup.js';
            $parser->addScript($src);
            $src = "
            <script type='text/javascript'>
            function dataimport(obj)
            {
                openWinc('".$parser->makeUrl('sys_admin_utils_import')."', 'callbackfunc=self.opener.global_".$w->container.".loadxml(0)&exp_objtype=wprod_categories&obj_classname=wproducts_models_categories');
            }
            </script>
            ";
            $parser->addScript($src);
        }

        $w->q->select('o.id',  $parser->gt('id'));
        $w->q->select('o.name', $parser->gt('name'), array('lang' => 1, 'edit' => $perm['u']));
        $w->q->select('o.totalitems',  $parser->gt('totalitems'));
        $w->q->select('o.enitems',  $parser->gt('enitems'));
        $w->q->select('o.sortorder',  $parser->gt('sortorder'));
        $w->q->select('o.url', $parser->gt('url'), array('edit' => $perm['u']));
        $w->q->from('wprod_categories o');
        $w->q->where("o.id<>'0'");
        $w->q->lorderby('o.name');

        $w->laddSearchField('o.name', $parser->gt('name'), 'C');

        $w->editing = $perm['u'];
        $w->adding = $perm['c'];
        $w->copying = $perm['c'];
        $w->deleting = $perm['d'];
        $w->multiselect = $perm['d'];


        $w->cardurl = $parser->makeUrl('wprod_categories_card');

        if($perm['u'])
        {
            $form_action = (isset($_REQUEST['form_action'])) ? $_REQUEST['form_action'] : '';
            switch($form_action)
            {
                case 'recalc':
                    $rs = $parser->conn->Execute("SELECT DISTINCT category FROM wprod_products WHERE id>0 AND category>0");
                    while($row = $rs->FetchRow())
                    {
                        $cat = $row[0];
                        $total = $parser->utils->getFieldFromSql("SELECT COUNT(*) FROM wprod_products WHERE category=".$cat, 0);
                        //$etotal = $parser->utils->getFieldFromSql("SELECT COUNT(*) FROM wprod_products WHERE published=1 AND category=".$cat, 0);
                        $etotal = $parser->utils->getFieldFromSql("SELECT COUNT(*)
                                                       FROM wprod_products p, wprod_categories c
                                                       WHERE (p.published=1)
                                                       AND (c.published=1)
                                                       AND (c.id=p.category)
                                                       AND (p.category=".$cat.")", 0);
                        $parser->conn->Execute("UPDATE wprod_categories SET totalitems=".$total.", enitems=".$etotal." WHERE id=".$cat);
                        while($cat)
                        {
                            $parent = $parser->utils->getFieldFromSql("SELECT parent FROM wprod_categories WHERE id=".$cat, 0);
                            $a = $parser->utils->getFieldsFromSql("SELECT SUM(totalitems), SUM(CASE WHEN published=1 THEN enitems ELSE 0 END) FROM wprod_categories WHERE parent=".$parent, array(0,0), 'num');
                            $parser->conn->Execute("UPDATE wprod_categories SET totalitems=".$a[0].", enitems=".$a[1]." WHERE id=".$parent);
                            $cat = $parent;
                        }

                    }
                break;
                case 'makeurls':
                    $rs = $parser->conn->Execute("SELECT id, name_".$parser->lang_suff.", url FROM wprod_categories WHERE (id>0)");
                    $output = '';
                    while($row = $rs->FetchRow())
                    {
                        $url = trim($row[2]);
                        if($url) continue;
                        $url = $parser->utils->ruTranslit(mb_strtolower(trim($row[1]), $this->config['charset']));
                        // Check uniqueness in Products
                        $url = str_replace(array(" ", "_", "&", "+", ".", ",", "/", "*", "'", "\"", "%", "(", ")", "?"),
                                           array("-", "-", "-", "-", "-", "-", "-", "-", "-", "-",  "-", "-", "-", "-"),
                                           $url);
                        $url = preg_replace('/[\-]+/','-', $url);
                        $url = trim($url, '-');
                        $url = preg_replace('/[^A-Za-z0-9\-]/', '', $url);

                        $n = $parser->utils->getFieldFromSql("SELECT id FROM wprod_products
                                                              WHERE (url='".$this->conn->escape($url)."')
                                                              AND (id<>".$row[0].")", 0);
                        if(!$n)
                        {
                            // Check uniqueness in Categoris
                            $n = $parser->utils->getFieldFromSql("SELECT id FROM wprod_categories
                                                                  WHERE (url='".$this->conn->escape($url)."')
                                                                  AND (id>0)", 0);

                        }
                        if(!$n)
                        {
                            // Check uniqueness in Pages
                            $n = $parser->utils->getFieldFromSql("SELECT objid FROM sys_objects
                                                                  WHERE (pagealias='".$this->conn->escape($url)."')
                                                                  AND (objtype='sys_elements_pages')", 0);

                        }

                        if($n) $url .= '-category-'.$row[0];
                        $parser->conn->Execute("UPDATE wprod_categories set url='".$url."' WHERE id=".$row[0]);
                    }
                break;
                case 'clearurls':
                        $parser->conn->Execute("UPDATE wprod_categories set url=''");
                break;
            }

            $w->addMainMenu0($parser->gt('functions'));
            $w->addMainMenu1($parser->gt('makeurls'), $action = 'javascript:makeurls');
            $w->addMainMenu1($parser->gt('clearurls'), $action = 'javascript:clearurls');
            $w->addMainMenu1($parser->gt('recalc'), $action = 'javascript:recalc');

            $src = "<script type=\"text/javascript\">
            function makeurls(obj)
            {
                ".$w->container."_postAction('makeurls', 0);
            }
            function clearurls(obj)
            {
                var q = window.confirm(\"".$parser->gt('atclearurls')."\");
                if(!q) return;
                ".$w->container."_postAction('clearurls', 0);
            }
            function recalc(obj)
            {
                ".$w->container."_postAction('recalc', 0);
            }
        	</script>";
            $parser->addScript($src);
        }


        $w->show();
?>