<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wprod_rights_prodcats');
    if(!$perm['r']) die($parser->gt('not_perms'));
    include_once(SYS_BASE_PATH.'main/classes/wajaxtreelist.class.php');
    $w = new wAjaxTreeList();
    $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_categories'", '');

    $w->f = new wproducts_models_categories();
    $w->en_mainmenu = false;

    $w->q->select('o.id',  $parser->gt('id'));
    $w->q->select('o.name', $parser->gt('name'), array('lang' => 1, ));
    $w->q->select('o.isfolder',  $parser->gt('isfolder'));
    $w->q->select('o.parent',  $parser->gt('parent'));
    $w->q->select('o.published',  $parser->gt('published'));
    $w->q->select('o.totalitems',  $parser->gt('totalitems'));
    $w->q->select('o.sortorder',  $parser->gt('sortorder'));

    // Insert here additional grid columns
    $w->q->from('wprod_categories o');
    $w->q->where("o.id<>'0'");
    $w->q->where("o.parent=:parent:");
    $w->q->orderby('o.sortorder');
    $w->q->lorderby('o.name');

    $w->editing = $perm['u'];
    $w->adding = $perm['c'];
    $w->copying = $perm['c'];
    $w->deleting = $perm['d'];


    $w->cardurl = $parser->makeUrl('wprod_categories_card');


    $w->show();
?>