<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class wproducts_models_categorieslang extends wPrototype
{

public function __construct($objtype = '', $id = '')
{
    $this->id = $id;
    parent::__construct('wprod_categories_lang');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
    $this->showformTinymceScript = true;
    $this->richedit_height = 300;
    $this->extendedTinymce = true;
}


/*
protected function _onUpdate()
{
    // Update Extra fields
    $pars = array();
    $pars['table'] = 'wprod_categories_lang_fields';
    $pars['objid'] = $this->_fields['objtype']['val'];
    $this->insertExtraFields($pars);
    return '';
}
*/

protected function _onBeforeInsert()
{
    global $parser;
    if($parser->config['seo_default_lang'] === $this->fields->lang->val) return 'default language';
    return '';
}


protected function _onBeforeShowForm()
{
    global $parser;
    if(!$this->id)
    {

    } else
    {
        $this->fields->lang->ro = true;
        $this->fields->categoryid->ro = true;
    }
    $this->fields->lang->type = 'select';
    //$this->fields->lang->options = 'de:de,en:en,es:es,fr:fr,ru:ru,ua:ua';
    $this->fields->lang->options = array(array('de', 'de'),
                                         array('en', 'en'),
                                         array('es', 'es'),
                                         array('fr', 'fr'),
                                         array('ru', 'ru'),
                                         array('ua', 'ua')
                                         );
    return '';
}


public function onBeforeCopy($id = 0)
{
    parent::onBeforeCopy($id);
    return '';
}

public function onCopy($id = 0)
{
    //global $parser;
    // Copy subobjects from original object

    return '';
}

}

?>