<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class wproducts_models_photo extends wPrototype
{
public $recalc = true;
public $productid = 0;
public $en_delete_all = false;

public function __construct($objtype = '', $id = '')
{
    $this->id = $id;
    parent::__construct('wprod_products_photo');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
}

protected function _onBeforeShowForm()
{
    $this->setFieldAttr('masterid', 'ro', 1);
}

protected function _onInsert()
{
    $this->recalcProduct();
    return '';
}

protected function _onBeforeDelete()
{
    global $parser;
    $parser->conn->Execute("UPDATE wprod_products SET imageid=0 WHERE imageid=".$this->id);
}

protected function _onDelete()
{
    global $parser;
    // delete files
    $ext = $parser->utils->getFieldFromSql("SELECT filetype
    FROM wprod_products_photo WHERE id=".$this->id, '');
    if(!$ext) $ext = 'jpg';
    $objectfolder = SYS_BASE_PATH.'userdata/modules/wproducts/wprod_products_photo';
    @unlink($objectfolder.'/icons/'.$this->id.'.'.$ext);
    @unlink($objectfolder.'/icons/'.$this->id.'_2.'.$ext);
    @unlink($objectfolder.'/'.$this->id.'.'.$ext);
    $this->recalcProduct();
    return '';
}

public function recalcProduct($prod = 0)
{
    global $parser;
    if(!$this->recalc) return;
    if(!$prod) $prod = $this->getFieldNewVal('masterid');
    $total = $parser->utils->getFieldFromSql("SELECT COUNT(*) FROM wprod_products_photo WHERE masterid=".$prod, 0);
    $parser->conn->Execute("UPDATE wprod_products SET photos=".$total." WHERE id=".$prod);
}


public function deleteAll($where = '', $sel = '')
{
    if($this->en_delete_all) return parent::deleteAll($where, $sel);
    if(!$this->productid) return '';
    $this->recalc = false;
    $this->extra_deleteAll_sql = '';
    parent::deleteAll(($where) ? $where : 'WHERE masterid IN('.$this->productid.')', $sel);
    $this->recalc = true;
    return $this->recalcProduct($this->productid);
}

}

?>