<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class wproducts_models_productstags extends wPrototype
{

public function __construct($objtype = '', $id = '')
{
    $this->id = $id;
    parent::__construct('wprod_products_tags');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
}



protected function _onBeforeInsert()
{
    global $parser;
    if($this->checkUniq()) return $parser->gt('must_unique','', '');
    return '';
}

protected function _onBeforeUpdate()
{
    global $parser;
    if($this->checkUniq()) return $parser->gt('must_unique','', '');
    return '';
}

protected function _onInsert()
{
    $this->recalcRating();
    return '';
}
protected function _onUpdate()
{
    $this->recalcRating();
    return '';
}
protected function _onDelete()
{
    $this->recalcRating();
    return '';
}

protected function checkUniq()
{
    global $parser;
    return $parser->utils->getFieldFromSql("SELECT id FROM wprod_products_tags
                                            WHERE (productid=".$this->fields->productid->newval.")
                                            AND (tagid=".$this->fields->tagid->newval.")
                                            AND (id<>".(($this->id) ? $this->id : 0).")
                                            ",
                                            '');
}

protected function recalcRating()
{
    global $parser;
    $total = $parser->utils->getFieldFromSql("SELECT COUNT(*) FROM wprod_products_tags WHERE tagid=".$this->fields->tagid->newval, 0);
    $parser->conn->Execute("UPDATE wprod_tags SET rating=".$total." WHERE id=".$this->fields->tagid->newval);
}

}

?>