<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class wproducts_models_rcomments extends wPrototype
{
protected $sql_root = '';
protected $sql = '';
public $pagelen = 20;
public $paginator_info = array();
protected $page = '';
public $author = '';
public $email = '';
public $reload = true;
public $fail_mess = 'cannotaddcomment';
public $success_mess = '';

public function __construct($objtype = '', $id = '')
{
    $this->id = $id;
    parent::__construct('wprod_rcomments');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
    $this->ro_form = true;
}


function showComments($itemid = 0, $page = 0)
{
    global $parser;
    if(!$itemid) return array();
    $this->page = $page;

    $action = isset($_REQUEST['action'])? $_REQUEST['action'] : '';
    $this->author = isset($_POST['author'])? $_POST['author'] : '';
    $this->email = isset($_POST['email'])? $_POST['email'] : '';
    $comment = isset($_POST['comment'])? $_POST['comment'] : '';
    $parent = isset($_POST['parent'])? $_POST['parent'] : '';
    $captchastring = isset($_POST['captchastring'])? $_POST['captchastring'] : '';
    $assessment = isset($_POST['assessment'])? $_POST['assessment'] : 0;

    $active_client = $_SESSION['wsales']['active_client'];
    if(!$this->author and !$this->email and $active_client)
    {
        $a =  @$parser->utils->getFieldsFromSql("SELECT id, firstname, email FROM wcrmp_company WHERE id=".$active_client, array(0, '', ''), 'num');
        if($a)
        {
            $this->author = $a[1];
            $this->email = $a[2];
        }
    }

    switch($action)
    {
        case 'addcoment':
            if(ob_get_length()) ob_clean();
            if(!trim($this->author) or !trim($this->email) or !trim($comment))
            {
                print($parser->gt('valuereq'));
                exit;
            }
            if(!$parser->utils->checkmail($this->email))
            {
                print($parser->gt('wrongemail'));
                exit;
            }
            if(isset($_SESSION['captcha']))
            {
                if($_SESSION['captcha'] != $captchastring)
                {
                    print($parser->gt('wrongcaptcha'));
                    exit;
                }
            }
/*
            if($this->sendmailto)
            {
                $pars = array('to' => $this->sendmailto,
                              'subject' => 'New message for you',
                              'message' => $email.' '.$comment
                              );
                $res = $parser->utils->sendMail($pars);
                if($res) $parser->addMessage('email error: '.$res, 2);
                if($this->sendintmailto) $parser->intMail($this->sendintmailto,  strip_tags($email.' '.$comment));
            }
            elseif($this->sendintmailto)
            {
                $parser->intMail($this->sendintmailto, strip_tags($email.' '.$comment));
            }
*/

            $this->setFieldNewVal('masterid', $itemid);
            $this->setFieldNewVal('username', strip_tags($this->author));
            $this->setFieldNewVal('userip', $_SERVER['REMOTE_ADDR']);
            $this->setFieldNewVal('userid',  $parser->utils->strToFloat($active_client));
            $this->setFieldNewVal('email', $this->email);
            $this->setFieldNewVal('isfolder', 0);
            $this->setFieldNewVal('parent', 0);
            $this->setFieldNewVal('createdon', $parser->utils->toDate('', true));
            $this->setFieldNewVal('comments', strip_tags($comment));
            $this->setFieldNewVal('parent', $parent);
            $this->setFieldNewVal('assessment', $assessment);

            $s = $this->insert();

            if($s) print('false');
            else
            {
                $cnt = $parser->utils->getFieldFromSql("SELECT COUNT(*) FROM wprod_rcomments WHERE masterid=".$itemid, 0);
                $a = $parser->utils->getFieldsFromSql("SELECT COUNT(*) AS CNT, SUM(assessment) AS SSS
                                                       FROM wprod_rcomments WHERE assessment>0 AND masterid=".$itemid, array(0,0), 'num');
                $rating = 0;
                if($a[0])  $rating = $parser->utils->mround($a[1] / $a[0], 0.01);
                $parser->conn->Execute("UPDATE wprod_reviews SET comments=".$cnt.", rating=".$rating." WHERE id=".$itemid);
            }
            print('');
            exit;
        break;
    }


    include_once(SYS_BASE_PATH.'main/classes/wsql.class.php');
    $q = new wSql();
    $q->select('c.id');
    $q->select('c.username');
    $q->select('c.createdon');
    $q->select('c.comments');
    $q->select('c.userid');
    $q->select('u.firstname');
    $q->select('c.isfolder');
    $q->from('wprod_rcomments c');
    $q->from('wcrmp_company u');
    $q->where('c.userid=u.id');
    $q->where("c.parent=0");
    $q->where("c.masterid=".$itemid);
    $q->orderby('c.id DESC');
    $this->sql_root = $q->getSql();

    $totalpages = 0;
    $this->paginator_info = array('page' => 0,
                  'numrows' => 0,
                  'pagelen' => $this->pagelen,
                  'totalpages' => 0
    );
    $pg = $q->parseSql($this->sql_root, true);
    $totalpages = ceil ($pg['rows'] / $this->pagelen);
    $numrows = $pg['rows'];
    if($this->page >= $totalpages) $this->page = $totalpages - 1;
    if($this->page < 0) $this->page = 0;
    $this->paginator_info = array('page' => $this->page,
                  'numrows' => $numrows,
                  'pagelen' => $this->pagelen,
                  'totalpages' => $totalpages
    );

    $q = new wSql();
    $q->select('c.id');
    $q->select('c.username');
    $q->select('c.createdon');
    $q->select('c.comments');
    $q->select('c.userid');
    $q->select('u.firstname');
    $q->select('c.isfolder');
    $q->from('wprod_rcomments c');
    $q->from('wcrmp_company u');
    $q->where('c.userid=u.id');
    $q->where("c.parent=:parent:");
    $q->where("c.masterid=".$itemid);
    $q->orderby('c.id');
    $this->sql = $q->getSql();

    $h2 = '';
    $parser->utils->addjq();
    $src = "<script type=\"text/javascript\">
    var replyParent = 0;
    function reply(comid)
    {
        $('#formli_' + comid).append($('#add_comment'));
        replyParent = comid;
    }

    $(document).ready(function()
    {
        //$(\"#commentform\").submit(function()
        $(\"#submitter\").click(function()
        {
            //remove all the class add the messagebox classes and start fading
            $('#msgbox').removeClass().addClass('messagebox').text('".$parser->gt('validating')."....').fadeIn(1000);
            $('#submitter').attr('disabled','disabled');
            $.post(\"".$parser->makeUrl($parser->pageId)."\",
            {   'action':'addcoment',
                'author':$('#author').val(),
                'email':$('#email').val(),
                'comment':$('#comment').val(),
                'captchastring':$('#captchastring').val(),
                'parent':replyParent,
                'assessment':$('input:radio[name=assessment]:checked').val(),
                'reviewid':'".$itemid."',
                ".$h2."
                'rand':Math.random()
            },
            function(data)
            {
                $('#submitter').removeAttr('disabled');
                if(data == 'false')
                {
                    $(\"#msgbox\").fadeTo(200,0.1,function()
                    {
                        $(this).html('".$parser->gt($this->fail_mess)."').addClass('messageboxerror').fadeTo(900,1);
                    });
                    return false;
                }
                else
                {
                    if(data)
                    {
                        $(\"#msgbox\").fadeTo(200,0.1,function()
                        {
                            $(this).html(data).addClass('messageboxerror').fadeTo(900,1);
                        });
                        return false;
                    }
    ";
    if($this->success_mess)
    $src .= "
                    $('#msgbox').removeClass().addClass('messageboxok').text('".$parser->gt($this->success_mess)."').fadeIn(1000);
     ";
    if($this->reload)
    $src .= "
                    $(\"#commentform\").submit();
     ";
    $src .= "
                    return false;
                }
            });
        });
    });

    </script>";
    $parser->addScript($src);


    return $this->printRecure();
}

protected function printRecure($par = 0)
{
    global $parser;
    $res = array();
    $rs = (!$par) ? $parser->conn->SelectLimit($this->sql_root, $this->pagelen, $this->page * $this->pagelen) : $parser->conn->SelectLimit(str_replace(':parent:', $par, $this->sql), 200, 0);

    if($rs->NumRows() <= 0) return $res;
    while($row = $rs->FetchRow())
    {
        $res[] =  array('username' => $row[1],
                        'createdon' =>  $rs->UserTimeStamp($row[2], $parser->gs('sys_user_dateformat').' H:i'),
                        'comments' => $row[3],
                        'childes' => (($row[6]) ? $this->printRecure($row[0]) : array()),
                        'id' => $row[0]);
    }
    return $res;
}

}

?>