<?php

// Category
$_lang['prodcat'] = 'Каталог товаров';
$_lang['category'] = 'Категория';
$_lang['categories'] = 'Категории';
$_lang['allcategories'] = 'Все категории';
$_lang['published'] = 'Доступен';
$_lang['sortorder'] = 'Порядок сортировки';
$_lang['sortorders'] = 'П';
$_lang['updateon'] = 'Изменён';
$_lang['totalitems'] = 'Всего товаров';
$_lang['enitems'] = 'Доступных товаров';
$_lang['attrgr'] = 'Набор характеристик';

// Products
$_lang['product'] = 'Товар';
$_lang['products'] = 'Товары';
$_lang['artikul'] = 'Артикул';
$_lang['manufacter'] = 'Производитель';
$_lang['manufacters'] = 'Производители';
$_lang['taxclass'] = 'Класс налогов';
$_lang['tax'] = 'Налог';
$_lang['prodtype'] = 'Тип товара';
$_lang['qtis'] = 'Количества, размеры, вес';
$_lang['ordered'] = 'Заказано';
$_lang['weight'] = 'Вес';
$_lang['length'] = 'Длина';
$_lang['width'] = 'Ширина';
$_lang['height'] = 'Высота';
$_lang['weightclass'] = 'Единица веса';
$_lang['lengthclass'] = 'Единица длины';
$_lang['qtyclass'] = 'Единица количества';
$_lang['viewed'] = 'Просмотров';
$_lang['cost'] = 'Себестоимость';
$_lang['taxcost'] = 'Себестоимость с налогами';
$_lang['optprice'] = 'Сумма опций';
$_lang['optpricewotax'] = 'Сумма опций без налогов';
$_lang['newitem'] = 'Новинка';
$_lang['newitems'] = 'Новинки';
$_lang['latest'] = 'Последние поступления';
$_lang['recommended'] = 'Мы рекомендуем';
$_lang['rating'] = 'Рейтинг';
$_lang['photos'] = 'Фотографий';
$_lang['specprice'] = 'Спец. предложение';
$_lang['reviews'] = 'Обзоры';
$_lang['views'] = 'Просмотров';
$_lang['added'] = 'Добавлен';
$_lang['taxprice'] = 'Цена с налогами';
$_lang['pricewotax'] = 'Цена без налогов';
$_lang['ourchoice'] = 'Наш выбор';
$_lang['shortdescr'] = 'Аннотация';
$_lang['prodage'] = 'Возраст товара';
$_lang['notavailable'] = 'Если нет на складе';
$_lang['needdelivery'] = 'Нужна доставка';
$_lang['geozone'] = 'Геозона';
$_lang['comcode'] = 'Код';
$_lang['model'] = 'Модель';
$_lang['income'] = 'Приход';
$_lang['expected'] = 'Ожидается';
$_lang['expense'] = 'Расход';
$_lang['reserve'] = 'Резерв';
$_lang['downloads'] = 'Загрузок';
$_lang['photo'] = 'Фото';
$_lang['noattrgr'] = 'В категории не указан набор характеристик';
$_lang['clipurl'] = 'Видео (url)';
$_lang['allmanufacter'] = 'Все производители';
$_lang['allenabled'] = 'Все (доступ)';
$_lang['stockqty'] = 'Наличие';
$_lang['production'] = 'Производство';
$_lang['minqty'] = 'Мин. запас';
$_lang['maxqty'] = 'Макс. запас';
$_lang['reordqty'] = 'Норма закупки';
$_lang['reordlevel'] = 'Уровень перезаказа';
$_lang['extracats'] = 'Доп. категории';
$_lang['prodgroups'] = 'Группы товаров';
$_lang['setasdownload'] = 'Сделать загрузочным';
$_lang['allproducts'] = 'Все товары';
$_lang['volume'] = 'Объём';
$_lang['volumeclass'] = 'Единица объёма';
$_lang['lineup'] = 'Модельный ряд';
$_lang['attributes'] = 'Характеристики';
$_lang['attribute'] = 'Характеристика';
$_lang['attributetype'] = 'Тип характеристики';
$_lang['attributetypes'] = 'Типы характеристик';
$_lang['estatetype'] = 'Тип недвижимости';
$_lang['region'] = 'Регион';
$_lang['latitude'] = 'Широта';
$_lang['longitude'] = 'Долгота';
$_lang['realestate'] = 'Недвижимость';
$_lang['booking'] = 'Бронирование';
$_lang['rates'] = 'Тарифы';

// Database
$_lang['clear'] = 'Удалить данные';
$_lang['clearedok'] = 'Данные удалены успешно';
$_lang['cannotclear'] = 'Не удалось удалить';
$_lang['doimport'] = 'Импортировать';
$_lang['importcatsatten'] = 'Внимание! Будут импортированы категории товаров из файла ';
$_lang['csv_delimiter'] = 'Разделитель поля';
$_lang['csv_enclosure'] = 'Ограничитель поля';
$_lang['cannotimport'] = 'Не удалось импортировать';
$_lang['fieldsnotfound'] = 'Обязательные поля не найдены';
$_lang['importcomplete'] = "Импорт завершён. Вставлено %d, Обновлено %d, Пропущено %d строк";
$_lang['importprodsatten'] = 'Внимание! Будут импортированы товары из файла ';
$_lang['toexcelcsv'] = 'Экспорт в CSV';
$_lang['importfromerp'] = 'Импорт из ERP';
$_lang['enterconpars'] = 'Введите параметры соединения';

$_lang['makeurls'] = 'Генерировать url';
$_lang['clearurls'] = 'Очистить url';
$_lang['atclearurls'] = 'Вы действительно хотите очистить все url?';

$_lang['fromdate'] = 'С';
$_lang['todate'] = 'По';

// Real Estate
$_lang['starton'] = 'Начало';
$_lang['finishon'] = 'Окончание';
$_lang['days'] = 'Дней';
$_lang['age'] = 'Возраст';
$_lang['numberadults'] = 'Взрослых';
$_lang['numberchildren'] = 'Детей';
$_lang['confirmed'] = 'Подтверждено';
$_lang['notconfirmed'] = 'Не подтверждено';
$_lang['confirmedon'] = 'Дата подтверждения';
$_lang['needtransfer'] = 'Нужен трансфер';
$_lang['flightinfo'] = 'Информация о полёте';
$_lang['transfer'] = 'Трансфер';
$_lang['badperiod'] = 'Некорректный период';
$_lang['minperiod'] = "Период не может быть меньше %s дней";
$_lang['maxperiod'] = "Период не может быть больше %s дней";
$_lang['objectbusy'] = 'В этом периоде есть занятые дни';

$_lang['tag'] = 'Метка';
$_lang['tags'] = 'Метки';

$_lang['alllanguages'] = 'Все языки';
$_lang['localization'] = 'Локализация';
$_lang['makelangs'] = 'Создать локализацию';
$_lang['atmakelangs'] = 'Вы действительно хотите создать локализацию?';

$_lang['makemetadesc'] = 'Создать meta-description';
$_lang['clearmetadesc'] = 'Очистить meta-description';
$_lang['imakemetadesccomplete'] = "Обновлено %d товаров";
$_lang['imakemetadesccompletec'] = "Обновлено %d категорий";
$_lang['chooselang'] = 'Выберите язык';
$_lang['makemetah1'] = 'Создать meta-h1';
$_lang['clearmetah1'] = 'Очистить meta-h1';
$_lang['makemetatitle'] = 'Создать meta-title';
$_lang['clearmetatitle'] = 'Очистить meta-title';

$_lang['mainattr'] = 'Главная';

$_lang['allgoodsfields'] = 'Все поля товаров';
$_lang['onlyenames'] = 'Только названия';
$_lang['onlyexported'] = 'Только экспортируемые';
$_lang['choosecategory'] = 'Выберите категорию';
$_lang['allcharfields'] = 'Все характеристики';
$_lang['onlyemain'] = 'Основные';

$_lang['viewform'] = 'Форма отображения';
$_lang['synonyms'] = 'Синонимы';
$_lang['searchword'] = 'Что искали';

//$_lang[''] = '';


?>