<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $objid = (isset($_REQUEST['objid'])) ? $_REQUEST['objid'] : '0';
    $filter_folder = (isset($_REQUEST['filter_folder'])) ? $_REQUEST['filter_folder'] : '';

    // Create new instance of the wAjaxCrosstab class
    include_once(SYS_BASE_PATH.'main/classes/wajaxcrosstab.class.php');
    $w = new wAjaxCrosstab();

    $pars = array();
    $pars['onchange'] = $w->container."_postAction('',0)";
    $pars['name'] = 'filter_folder';
    $pars['emptyval'] = 0;
    $pars['tree_btn'] = 0;
    $pars['emptyrefval'] = $parser->gt('all', __FILE__);
    $pars['val'] = $filter_folder;
    $pars['objtype'] = 'wprod_prodspecs';
    $pars['extra_pars'] = 'AND (isfolder=1) ';
	$pars['folder_select'] = 1;

    $w->addCell($parser->utils->finder($pars));

    // Set object types for rows and columns
    $w->col_objtype = 'wprod_prodspecs_gr';
    $w->row_objtype = 'wprod_prodspecs';
    $w->addHidden('objid', $objid);
    $w->row_extra_filter .= "AND (isfolder=0) ";
    if($filter_folder) $w->row_extra_filter .= "AND (parent='".$filter_folder."') ";

    // Allow editing
    $w->editing = true;

    // Print the cross-table
    $w->show();
?>