<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wprod_rights_products');
    if(!$perm['r']) die($parser->gt('not_perms'));

    include_once(SYS_BASE_PATH.'main/classes/calendar.class.php');
    $w = new calendar('wprod_booking');
    $w->f = new wproducts_models_booking();

    $filter_productid = (isset($_REQUEST['filter_productid'])) ? $_REQUEST['filter_productid'] : '';
    $filter_confirmed = (isset($_REQUEST['filter_confirmed'])) ? $_REQUEST['filter_confirmed'] : '';


    $active_tab =  (isset($active_tab)) ? $active_tab : '0';
    $cat_id =  (isset($cat_id)) ? $cat_id : '0';
    $callbackfunc =  (isset($callbackfunc)) ? $callbackfunc : '';

    if($cat_id)
    {
        $filter_productid = $cat_id;
    }


    $w->q->select('o.id');
    $w->q->select('o.firstname');
    $w->q->select('o.starton');
    $w->q->select('o.finishon');
    $w->q->select("'' AS color");
    $w->q->from('wprod_booking o');
    $w->q->where("o.id<>'0'");
    $w->q->where('(o.starton>=:start: AND o.finishon<:end:) OR (o.starton<:start: AND o.finishon>:start:) OR (o.starton<:end: AND o.finishon>=:end:)');

    $w->editable = $perm['u'];
    $w->selectable = $perm['c'];

    switch($filter_confirmed)
    {
        case 1:	 $w->q->where("o.confirmed=1");
        break;
        case 2:	 $w->q->where("o.confirmed=0");
        break;
    }
    if($filter_productid)
    {
        $mfilter_productid = $parser->utils->addQuots($filter_productid);
        $w->q->where("o.productid IN(".$mfilter_productid.")");
        $w->f->fields->productid->val = $filter_productid;
    }
    $pars = array();
    $pars['onchange'] = "postAction('',0)";
    $pars['name'] = 'filter_confirmed';
    $pars['val'] = $filter_confirmed;
    $pars['options'] = array($parser->gt('all'), $parser->gt('confirmed'), $parser->gt('notconfirmed'));
    $w->addCell($parser->utils->dropdownMenu($pars));

    if(!$cat_id)
    {
        $this->popup_script = true;
        $pars = array();
        $pars['onchange'] = "postAction('',0)";
        $pars['name'] = 'filter_productid';
        $pars['emptyval'] = 0;
        $pars['tree_btn'] = 0;
        $pars['emptyrefval'] = $parser->gt('allproducts');
        $pars['val'] = $filter_productid;
        $pars['objtype'] = 'wprod_products';
        $pars['extra_pars'] = " AND (prodtype='wprod_prodtypes_estate') ";
        $w->addCell($parser->utils->finder($pars));
    }
    $w->addHidden('active_tab', $active_tab);
    $w->addHidden('cat_id', $cat_id);
    $w->addHidden('callbackfunc', $callbackfunc);

    //$w->caption = $parser->gt('calendar');
    $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_booking'", '');
    $w->defaultView = '';
    $w->show();
?>