<?php
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wprod_rights_prodcats');
    if(!$perm['r']) die($parser->gt('not_perms'));
    $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;

    //$unload = ($callbackfunc) ? " onunload=\"".$callbackfunc."\"" : '';

    include_once(SYS_BASE_PATH.'main/classes/wcatalog.class.php');
    class wtablecat extends wCatalog
    {
        public $perm = array('c' => 0, 'r' => 0, 'u' => 0, 'd' => 0);
        public function _titleframe()
        {
            global $parser;
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;
            $parent = (isset($_REQUEST['parent'])) ? $_REQUEST['parent'] : 0;
            $this->addHidden('parent', $parent);
            $this->f = new wproducts_models_categories();
            $this->title = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_categories'", '');

            $this->addMenu(0, $parser->gt('card'), !$active_tab);
            $this->addMenu(1, $parser->gt('products'), ($active_tab == 1));
            $this->addMenu(2, $parser->gt('localization'), ($active_tab == 2));
            $this->addMenu(3, $parser->gt('log'), ($active_tab == 3));
            $this->extra_from = '';
            $this->extra_where = '';
        }
        public function _content()
        {
            global $parser;
            $cat_id = (isset($_REQUEST['cat_id'])) ? $_REQUEST['cat_id'] : '';
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;
            $card_onload_par = (isset($_REQUEST['card_onload_par'])) ? $_REQUEST['card_onload_par'] : '';
            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';
            $action = (isset($_REQUEST['action'])) ? $_REQUEST['action'] : '';
            $formid = (isset($_REQUEST['formid'])) ? $_REQUEST['formid'] : 0;
            if(!$this->adding and !$cat_id) return $parser->gt('no_data_found');
            $output = '';
            switch($active_tab)
            {
                case 0:
                    $parser->addScript(SYS_BASE_URL.'main/js/popup.js');
                    $f = new wproducts_models_categories($this->objtype, $cat_id);
                    $f->buttonpanel = 'buttonpanelm';
                    $f->id = $cat_id;
                    $f->only_card = true;
                    $f->container = 'wprod_categories_cat';
                    $form_action = (isset($_POST['form_action'])) ? $_POST['form_action'] : '';
                    switch($form_action)
                    {
                        case 'edit':
                            $f->read();
                            $s = $f->update(true);
                            if($s) print($s);
                            if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                        break;
                        case 'insert':
                            $s = $f->insert(true);
                            if($s)
                            {
                                $f->error_mess = $s;
                            }
                            else
                            {
                                if($card_onload_par) $f->onCopy($card_onload_par);
                                if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                                return "<SCRIPT LANGUAGE=\"JavaScript\">navigatetoid('".$f->id."');</SCRIPT>";
                            }
                        break;
                    }
                    $f->addHidden('callbackfunc', $callbackfunc);
                    $f->addHidden('cat_id', $cat_id);
                    $f->addHidden('active_tab', $active_tab);
                    $parser->addScript("<script type='text/javascript'>
                    function form_submit()
                    {
                        var btn = document.getElementById('submitbutton');
                        if(btn)
                        {
                            btn.value = '".$parser->gt('loading')."...';
                            btn.disabled = true;
                        }
                        $('#form_dialog_".$f->container."').submit();
                    }
                    </script>");
                    $f->en_autocomplete = true;
                    if($cat_id)
                    {
                        if($this->perm['u'])
                        {
                            $f->addHidden('form_action', 'edit');
                            $f->addButton($parser->gt('save'), 'form_submit()', 'submitbutton', 'button');
                        }
                    } else
                    {
                        if($this->perm['c'])
                        {
                            if($card_onload_par) $f->onBeforeCopy($card_onload_par);
                            $parent = (isset($_REQUEST['parent'])) ? $_REQUEST['parent'] : 0;
                            $f->setFieldVal('parent', $parent);
                            $f->addHidden('form_action', 'insert');
                            $f->addHidden('action', 'title_adding');
                            $f->addButton($parser->gt('insert'), 'form_submit()', 'submitbutton', 'button');
                            $f->addButton($parser->gt('cancel'), "navigateto('last')", '', 'button');
                        }
                    }

                    return $f->showForm();
                break;
                case 1: // Products
                    if(!$cat_id) return '';
                    $fn = __FILE__;
                    $perm = $parser->checkPerms('wprod_rights_products');
                    if(!$perm['r']) return $parser->gt('not_perms');
                    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
                    $w = new wAjaxGrid();
                    $w->edit_table_alias = 'o';

                    $w->f = new wproducts_models_products();
                    $w->f->category = $cat_id;
                    $w->en_mainmenu = false;
                    $a = $parser->utils->getFieldsFromSql('SELECT id, name_'.$parser->lang_suff.
                    ", isfolder, parent FROM wprod_categories WHERE id='".$cat_id."'", array(0,'',0,0), 'num');

                    $par = array('edit' => $perm['u']);

                    $w->q->select('o.id',  $parser->gt('id'));
                    $w->q->select('o.artikul', $parser->gt('artikul', $fn), $par);
                    $w->q->select('o.model', $parser->gt('model', $fn), $par);
                    $w->q->select('o.name', $parser->gt('name', $fn), array('lang' => true, 'edit' => $this->perm['u']));
                    $b = $parser->utils->getFieldsFromSql("SELECT flt1, flt2, flt3, str1_".$parser->lang_suff." FROM sys_objects WHERE objid='".$parser->gs('wprod_setting_curr')."'", array(0,0,0,''), 'num');
                    if($parser->gt('wprod_setting_showtaxes'))  $w->q->select('o.taxprice', $parser->gt('taxprice', $fn).' '.$b[3]);
                        else $w->q->select('o.price', $parser->gt('price', $fn).' '.$b[3]);
                    $w->q->select('o.income-o.expense AS qty', $parser->gt('qtys', $fn));
                    $w->rowclass_col = $w->q->select('o.color', $parser->gt('color'), array('hide' => 1));
                    $w->q->from('wprod_products o');
                    $w->q->where("o.id<>'0'");
                    if($a[2])
                    {
                        // folder
                        $w->q->lselect('c.name AS catname', $parser->gt('category'));
                        if($cat_id) $w->q->where("o.category IN(".$parser->utils->getAllChilds('select id from wprod_categories where id<>0 and parent=:parent:',
                            $cat_id, false, 0, false).")");
                        $w->q->from('wprod_categories c');
                        $w->q->where("o.category=c.id");
                    }
                    else
                    {
                        $w->adding = $perm['c'];
                        $w->copying = $perm['c'];
                        $w->deleting = $perm['d'];
                        $w->multiselect = $perm['d'];
                        $w->q->where("o.category=".$cat_id);
                    }
                    $w->q->lorderby('o.name');
                    $w->addingpars = 'category='.$cat_id;
                    $w->cardurl = $parser->makeUrl('wprod_products_card');
                    $w->editing = $perm['u'];

                    $w->addHidden('cat_id', $cat_id);
                    $w->addHidden('active_tab', $active_tab);
                    $w->addHidden('callbackfunc', $callbackfunc);
                    $w->show();
                break;
                case 2: // localization
                    include_once(SYS_BASE_PATH.'ext/wproducts/lib/categorieslanglist.php');
                break;
                case 3: // log
                    include_once(SYS_BASE_PATH.'main/system/log.php');
                break;
            }
        }
    }

    $cat = new wtablecat('wprod_categories');
    $cat->notreeframe = true;
    $cat->navigation = true;
    $cat->navibuttons = true;
    $cat->extra_from = '';
    $cat->extra_where = '';
    $cat->adding = $perm['c'];
    $cat->deleting = $perm['d'];
    $cat->perm = $perm;

    $width = 0;
    $cat->showTable($width);

?>