<?php
        // Check Rights
        if(!$parser->getUserId()) die($parser->gt('not_perms'));
        $perm = $parser->checkPerms('wprod_rights_comments');
        if(!$perm['r']) die($parser->gt('not_perms'));
        include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
        $w = new wAjaxGrid();
        $filter_masterid = (isset($_REQUEST['filter_masterid'])) ? $_REQUEST['filter_masterid'] : '';
        $filter_period = (isset($_REQUEST['filter_period'])) ? $_REQUEST['filter_period'] : 0;
        $w->f = new wproducts_models_comments();
        $w->edit_table_alias = 'o';
        //$w->caption = $parser->gt('wprod_comments', __FILE__);
        $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_comments'", '');

        $w->q->select('o.id',  $parser->gt('id'));
        $w->q->select('o.username', $parser->gt('user'), array('edit' => $perm['u']));
        $w->q->select('o.createdon', $parser->gt('createdon'));
        $w->q->lselect('p.name', $parser->gt('product'));
        $w->q->select('o.userip', 'IP');
        $w->q->select('o.assessment', $parser->gt('assessment'));
        $w->q->select('o.comments', $parser->gt('comment'));


        $w->q->from('wprod_comments o');
        $w->q->from('wprod_products p');
        $w->q->where("o.id<>'0'");
        $w->q->where("o.masterid=p.id");
        $w->q->orderby('o.createdon DESC');

        if($filter_period)
        {
             $per = $parser->utils->getPeriod($filter_period, true);
             $w->q->where("o.createdon ".$per);
             $w->f->extra_deleteAll_sql .= "AND (createdon ".$per.")";
        }
        if($filter_masterid)
        {
            $mfilter_masterid = $parser->utils->addQuots($filter_masterid);
            $w->q->where("o.masterid IN(".$mfilter_masterid.")");
            $w->f->extra_deleteAll_sql .= "AND masterid IN(".$mfilter_masterid.") ";
            $w->f->fields->masterid->val = $filter_masterid;
        }
        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_period';
        $pars['val'] = $filter_period;
        $w->addCell($parser->utils->periodMenu($pars));

        $w->popup_script = true;
        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_masterid';
        $pars['emptyval'] = 0;
        $pars['tree_btn'] = 0;
        $pars['emptyrefval'] = $parser->gt('all');
        $pars['val'] = $filter_masterid;
        $pars['objtype'] = 'wprod_products';
        $w->addCell($parser->utils->finder($pars));

        $w->addSearchField('o.username', $parser->gt('name'), 'C');
        $w->addSearchField('o.userip', $parser->gt('userip'), 'C');
        $w->addSearchField('o.email', $parser->gt('email'), 'C');
        $w->addSearchField('o.comments', $parser->gt('comments'), 'C');
        $w->addSearchField('o.assessment', $parser->gt('assessment'), 'I');

        $w->editing = $perm['u'];
        $w->adding = $perm['c'];
        $w->copying = $perm['c'];
        $w->deleting = $perm['d'];
        $w->multiselect = $perm['d'];


        if($perm['c'])
        {
            $w->addMainMenu0($parser->gt('import', SYS_BASE_PATH.'main/objects'), 'javascript:dataimport');
        	$src = SYS_BASE_URL.'main/js/clean/popup.js';
            $parser->addScript($src);
            $src = "
            <script type='text/javascript'>
            function dataimport(obj)
            {
                openWinc('".$parser->makeUrl('sys_admin_utils_import')."', 'callbackfunc=self.opener.global_".$w->container.".loadxml(0)&exp_objtype=wprod_comments');
            }
            </script>
            ";
            $parser->addScript($src);
        }


        $w->show();
?>