<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $active_tab =  (isset($active_tab)) ? $active_tab : '0';
    $callbackfunc =  (isset($callbackfunc)) ? $callbackfunc : '';
    $cat_id =  (isset($cat_id)) ? $cat_id : '0';
    $objid = ($cat_id) ? $cat_id :  ((isset($_REQUEST['objid'])) ? str_replace('_sl_', '/', $_REQUEST["objid"])  : '0');
    $objtype = (isset($_REQUEST['objtype'])) ? $_REQUEST['objtype'] : 'sys_elements_pages';

    // Create new instance of the wAjaxCrosstab class
    include_once(SYS_BASE_PATH.'main/classes/wajaxcrosstab.class.php');
    $w = new wAjaxCrosstab();
    $w->caption = $parser->gt('files').' - '.$parser->gt('roles');

    // Set object types for rows and columns
    $w->col_objtype = 'sys_rights_roles';
    $w->row_objtype = 'wprod_products';
    $w->row_extra_filter = " AND (prodtype='wprod_prodtypes_file') ";
    $w->col_extra_filter = " AND (isfolder=0) ";

    if($objid)
    {
        $w->reverse = true;
        $w->row_extra_filter .= " AND (id='".$objid."') ";
        $w->addHidden('objid', $objid);
        $w->addHidden('objtype', $objtype);
    }
    $w->addHidden('callbackfunc', $callbackfunc);
    $w->addHidden('active_tab', $active_tab);
    $w->addHidden('cat_id', $cat_id);
    // Allow editing
    $w->editing = true;

    // Print the cross-table
    $w->show();
?>