<?php
    // Check Rights
    $fn = __FILE__;
    if(!$parser->getUserId()) die($parser->gt('not_perms'));



    include_once(SYS_BASE_PATH.'main/utils/import.class.php');
    class imradprodimport extends wcatimport
    {
        public $filter_category = 0;
        public $filter_prodfields = 0;

        public function onbeforeshowfilelist($pars = array())
        {
            global $parser;
            $grid = $pars['grid'];
            $grid->popup_script = true;
            $ppars = array();
            $ppars['name'] = 'filter_category';
            $ppars['val'] = $this->filter_category;
            $ppars['emptyval'] = 0;
            //$ppars['tree_btn'] = 0;
            $ppars['emptyrefval'] = $parser->gt('allcategories', SYS_BASE_PATH.'ext/wproducts');
            $ppars['onchange'] = "filemanager_grid_postAction('',0)";
            $ppars['objtype'] = 'wprod_categories';
            $grid->addCell($parser->utils->finder($ppars));

            $ppars = array();
            $ppars['name'] = 'filter_prodfields';
            $ppars['val'] = $this->filter_prodfields;
            $ppars['options'] = array($parser->gt('allgoodsfields', __FILE__), $parser->gt('onlyenames'), $parser->gt('onlyexported'));
            $grid->addCell($parser->utils->dropdownMenu($ppars));

            parent::onbeforeshowfilelist($pars);
            $this->caption = $parser->utils->getFieldFromSql("SELECT name_".$parser->lang_suff." FROM ".
                        "sys_objects WHERE (objid = '".$parser->pageId."')", '');
        }

        public function import($filename = '')
        {
            global $parser;
            @set_time_limit(0);

            include_once SYS_BASE_PATH.'main/classes/wprototype.class.php';

            $this->exp_objtype = 'wprod_products';
            $this->obj_classname = 'wproducts_models_products';


            //      
            include_once(SYS_BASE_PATH.'main/classes/wphoto.class.php');
            $foto = new wPhoto();
            //$foto->container = 'wgrid';
            $foto->objtype = 'wprod_products';
            $foto->counter_field = 'photos';
            $foto->mainphoto_field = 'imageid';
            $foto->photoobjtype = 'wprod_products_photo';
            $foto->setObjectFolder('wproducts');


            $grid = new wTablem();
            $grid->objectfolder = $foto->objectfolder;
            $grid->delete_source = false;
            $grid->container = $foto->container;
            $grid->objecturl = SYS_BASE_URL.'userdata/modules/wproducts/'.$foto->photoobjtype;
            $grid->thumbsize = $parser->gs('sys_vars_thumbsize');
            $grid->thumbsize2 = $parser->gs('sys_vars_thumbsizesecond');
            $grid->unzip = false;
            $grid->domark = false;
            $grid->maxwidth = $parser->gs('sys_vars_maximagewidth');
            $grid->photoobjtype = $foto->photoobjtype;
            $grid->objtype = $foto->objtype;
            $grid->counter_field = $foto->counter_field;
            $grid->mainphoto_field = $foto->mainphoto_field;
            include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
            $grid->f = new wPrototype($foto->photoobjtype);
            $grid->f->en_log_insert = false;
            $grid->thumbsize = $parser->gs('wprod_setting_iconw');
            $grid->thumbsize2 = $parser->gs('wprod_setting_iconw2');
            $grid->maxwidth = $parser->gs('wprod_setting_photow');

            $classname = ($this->obj_classname) ? $this->obj_classname : 'wPrototype';

            $this->f = new $classname($this->exp_objtype);

            $a = explode('/',$filename);
            if($a[0] == 'userdata') $filename = SYS_BASE_PATH.$filename;
            if(!file_exists($filename)) return $parser->gt('filenotfound');

            $s = $parser->invokeEvent('sys_onBeforeStartImport', array('obj' => $this));
            if($s) return $s;

            $s = $this->onBeforeStartImport();
            if($s) return $s;

            $origin_fields = $this->f->_fields;
            $sync_fields = array();
            $sync_labels = array();
            $sync_orders = array();
            $sync_real = array();
            $sync_txt = '';
            $sync_exists = false;
            // Get sync fields

            $pdf_col = -1;
            $photo_col = -1;

            foreach ($this->f->_fields as $key => $value)
            {
                $name = $value['name'];
                if($value['key'] and !in_array($name, $sync_fields))
                {
                    $sync_fields[] = $name;
                    $sync_labels[] = $value['label'];
                    $sync_orders[] = 0;
                    continue;
                }
                if($value['sync'] and !in_array($name, $sync_fields))
                {
                    $sync_fields[] = $name;
                    $sync_labels[] = $value['label'];
                    $sync_orders[] = $value['sync'];
                    $sync_exists = true;
                    continue;
                }
            }
            array_multisort($sync_orders, $sync_fields, $sync_labels);

            $ext = strtolower(end((explode('.', $filename))));
            $i = 0;
            $this->log = "";
            $this->inserted = 0;
            $this->updated = 0;
            $this->skiped = 0;
            $csv_delimiter = ',';
            $csv_enclosure = '"';
            $fields_positions = array();

            switch($ext)
            {
                case 'csv':

                    ini_set("auto_detect_line_endings", true);
                    $file_handle = fopen($filename, "r");
                    while (!feof($file_handle) )
                    {
                        $line_of_text = fgetcsv($file_handle, 2048, $csv_delimiter, $csv_enclosure);

                        $s = $parser->invokeEvent('sys_onReadCSVRow', array('obj' => $this,'cnt' => $i,'row' => $line_of_text));
                        if($s)
                        {
                            $i++;
                            continue;
                        }

                        $s = $this->onReadCSVRow(array('cnt' => $i,
                                                       'row' => $line_of_text));
                        if($s)
                        {
                            $i++;
                            continue;
                        }

                        $empty_row = true;
                        if(!$i++)
                        {
                            // Find columns
                            for($j = 0; $j < sizeof($sync_labels); $j++)
                            {
                                //$fldn = $sync_fields[$j];

                                for($k = 0; $k < sizeof($line_of_text); $k++)
                                {
                                    $tmpl = strtolower(trim($line_of_text[$k]));
                                    if(strpos($tmpl, "(id)") !== false) $tmpl = 'id';

                                    //if(strtolower(trim($line_of_text[$k])) == strtolower(trim($sync_labels[$j])))
                                    if($tmpl == strtolower(trim($sync_labels[$j])))
                                    {
                                        $sync_real[] = array($k, $sync_fields[$j]);
                                        $sync_txt .= ($sync_txt) ? ', '.$this->f->_fields[$sync_fields[$j]]['label'] : $this->f->_fields[$sync_fields[$j]]['label'];
                                        continue 2;
                                    }
                                }
                            }
                            for($k = 0; $k < sizeof($line_of_text); $k++)
                            {
                                $tmpl = mb_strtolower(trim($line_of_text[$k]), $parser->config['charset']);
                                if($tmpl === $parser->gtl('pdf')) $pdf_col = $k;
                                    elseif($tmpl === $parser->gtl('photo', SYS_BASE_PATH.'ext/wproducts')) $photo_col = $k;

                                $fld = '';
                                foreach ($this->f->_fields as $key => $value)
                                {
                                    $tmpl = strtolower(trim($line_of_text[$k]));
                                    if(strpos($tmpl, "(id)") !== false) $tmpl = 'id';

                                    //if(strtolower(trim($line_of_text[$k])) == strtolower(trim($value['label'])))
                                    if($tmpl == strtolower(trim($value['label'])))
                                    {
                                        $fld = $key;
                                        break;
                                    }
                                }
                                $fields_positions[] = $fld;
                            }
                            if(!sizeof($sync_real)  and $sync_exists)
                            {
                                fclose($file_handle);
                                return  $parser->gt('nosyncfields', SYS_BASE_PATH.'main/classes');
                            }
                            continue;
                        }
                        // Check for existing object;
                        $old_id = '';
                        for($j = 0; $j < sizeof($sync_real); $j++)
                        {
                            $suff = ($this->f->_fields[$sync_real[$j][1]]['lang']) ? '_'.$parser->lang_suff : '';
                            $sql = "SELECT ".$this->f->keyfield." FROM ".$this->f->table."
                                    WHERE ".$this->f->keyfield."<>'0'
                                    AND ".$sync_real[$j][1].$suff."<>'0'
                                    AND ".$sync_real[$j][1].$suff."<>''
                                    AND ".$sync_real[$j][1].$suff." = '".
                                    $parser->conn->escape($line_of_text[$sync_real[$j][0]])."'";
                            $old_id = $parser->utils->getFieldFromSql($sql, '');
                            if($old_id) break;
                        }
                        $this->f->_fields = $origin_fields;

                        $this->f->id = ($old_id) ? $old_id : 0;
                        if($this->f->id) $this->f->read();
                        // Set fields values
                        for($k = 0; $k < sizeof($line_of_text); $k++)
                        {
                            if(strlen(trim($line_of_text[$k])) and (trim($line_of_text[$k]) != '-')) $empty_row = false;
                            if(($fields_positions[$k] == $this->f->keyfield) || !$fields_positions[$k]) continue;
                            $val = rtrim($line_of_text[$k]);
                            if(strlen($this->f->fields->$fields_positions[$k]->type) > 1)
                            {
                                $a = $this->getrefid($this->f->fields->$fields_positions[$k]->type, $val);
                                if($a['mess'])
                                {
                                    $this->log .= $i." - ".$a['mess']."\n";
                                    $this->skiped++;
                                    continue 2;

                                }
                                $val = $a['id'];
                            }
                            $this->f->fields->$fields_positions[$k]->newval = $val;
                        }
                        if($empty_row)
                        {
                            $this->log .= $i." - ".$parser->gt('emptyrow', SYS_BASE_PATH.'main/classes')."\n";
                            $this->skiped++;
                            continue;
                        }
                        $s = ($old_id) ? $this->f->update() : $this->f->insert();
                        if($s)
                        {
                            $this->log .= $i." - ".$s."\n";
                            $this->skiped++;
                        } else
                        {
                            //  
                            if($pdf_col >= 0)
                            {
                                $val = trim($line_of_text[$pdf_col]);
                                $s = ($val) ? $this->importPdf($this->f->id, $val) : '';
                                if($s) $this->log .= $i." - ".$s."\n";
                            }

                            //  
                            if($photo_col >= 0)
                            {
                                $val = trim($line_of_text[$photo_col]);
                                $s = ($val) ? $this->importPhoto($this->f->id, $val, $grid) : '';
                                if($s) $this->log .= $i." - ".$s.' '.$val."\n";
                            }

                            if($old_id)
                            {
                                $this->updated++;
                            }
                        }

                    }
                    fclose($file_handle);

                    if($this->log) $parser->toFile($this->log, $parser->utils->userdir().'/'.'log'.date('Ymd-Hi').'.txt');
                    //return $sync_txt.'<br />'.$this->inserted.', '.$this->updated.'<br />'.implode(',',$fields_positions);
                    return $parser->gt('importcomplete', SYS_BASE_PATH.'main/classes', $this->inserted, $this->updated, $this->skiped);
                break;
                case 'xls':
                case 'xlsx':
                    include_once(SYS_BASE_PATH.'libs/excel/PHPExcel.php');
                    $inputFileType = PHPExcel_IOFactory::identify($filename);
                    $objReader = PHPExcel_IOFactory::createReader($inputFileType);
                    $objReader->setReadDataOnly(true);

                    $objPHPExcel = $objReader->load($filename);
                    $total_sheets = $objPHPExcel->getSheetCount();
                    $allSheetName = $objPHPExcel->getSheetNames();
                    $objWorksheet = $objPHPExcel->setActiveSheetIndex(0);
                    $highestRow = $objWorksheet->getHighestRow();
                    $highestColumn = $objWorksheet->getHighestColumn();
                    $highestColumnIndex = PHPExcel_Cell::columnIndexFromString($highestColumn);
                    $collabels = array();
                    foreach ($this->f->_fields as $key => $value) $collabels[] = $value['label'];
                    for ($row = 1; $row <= $highestRow; ++$row)
                    {
                        $s = $parser->invokeEvent('sys_onReadExcelRow', array('obj' => $this,
                                                         'cnt' => $i,
                                                         'row' => $row,
                                                         'worksheet' => $objWorksheet,
                                                         'cols' => $highestColumnIndex));
                        if($s)
                        {
                            $i++;
                            continue;
                        }

                        $s = $this->onReadExcelRow(array('cnt' => $i,
                                                         'row' => $row,
                                                         'worksheet' => $objWorksheet,
                                                         'cols' => $highestColumnIndex));
                        if($s)
                        {
                            $i++;
                            continue;
                        }

                        if(!$i++)
                        {
                            // Find columns
                            for($j = 0; $j < sizeof($sync_labels); $j++)
                            {
                                for ($col = 0; $col <= $highestColumnIndex; ++$col)
                                {
                                    if(strtolower(trim($objWorksheet->getCellByColumnAndRow($col, $row)->getValue())) == strtolower(trim($sync_labels[$j])))
                                    {
                                        $sync_real[] = array($col, $sync_fields[$j]);
                                        $sync_txt .= ($sync_txt) ? ', '.$this->f->_fields[$sync_fields[$j]]['label'] : $this->f->_fields[$sync_fields[$j]]['label'];
                                        continue 2;
                                    }
                                }
                            }
                            for ($col = 0; $col <= $highestColumnIndex; ++$col)
                            {
                                $tmpl = mb_strtolower(trim($objWorksheet->getCellByColumnAndRow($col, $row)->getValue()), $parser->config['charset']);
                                if(!trim($tmpl) || ($tmpl == '-')) continue;
                                if($tmpl === $parser->gtl('pdf')) $pdf_col = $col;
                                    elseif($tmpl === $parser->gtl('photo', SYS_BASE_PATH.'ext/wproducts')) $photo_col = $col;

                                $fld = '';
                                foreach ($this->f->_fields as $key => $value)
                                {
                                    if(strtolower(trim($objWorksheet->getCellByColumnAndRow($col, $row)->getValue())) == strtolower(trim($value['label'])))
                                    {
                                        $fld = $key;
                                        break;
                                    }
                                }
                                $fields_positions[] = $fld;
                            }
                            if(!sizeof($sync_real) and $sync_exists) return  $parser->gt('nosyncfields', SYS_BASE_PATH.'main/classes');
                            continue;
                        }
                        // Check for existing object;
                        //$parser->toFile(implode(', ',$sync_labels));
                        //break;
                        $old_id = '';
                        for($j = 0; $j < sizeof($sync_real); $j++)
                        {
                            $suff = ($this->f->_fields[$sync_real[$j][1]]['lang']) ? '_'.$parser->lang_suff : '';
                            $sql = "SELECT ".$this->f->keyfield." FROM ".$this->f->table."
                                    WHERE ".$this->f->keyfield."<>'0'
                                    AND ".$sync_real[$j][1].$suff."<>'0'
                                    AND ".$sync_real[$j][1].$suff."<>''
                                    AND ".$sync_real[$j][1].$suff." = '".
                                    $parser->conn->escape($objWorksheet->getCellByColumnAndRow($sync_real[$j][0], $row)->getValue())."'";
                            $old_id = $parser->utils->getFieldFromSql($sql, '');
                            if($old_id) break;
                            //$parser->addMessage(htmlspecialchars($sql), 3);
                        }

                        $this->f->_fields = $origin_fields;

                        $this->f->id = ($old_id) ? $old_id : 0;
                        if($this->f->id) $this->f->read();
                        // Set fields values
                        for ($col = 0; $col <= $highestColumnIndex; ++$col)
                        {
                            if(!isset($fields_positions[$col])) continue;
                            if(($fields_positions[$col] == $this->f->keyfield) || !$fields_positions[$col]) continue;
                            $cell = $objWorksheet->getCellByColumnAndRow($col, $row);
                            $val = rtrim($cell->getValue());
                            if(strlen($this->f->fields->$fields_positions[$col]->type) > 1)
                            {
                                $a = $this->getrefid($this->f->fields->$fields_positions[$col]->type, $val);
                                if($a['mess'])
                                {
                                    $this->log .= $i." - ".$a['mess']."\n";
                                    $this->skiped++;
                                    continue 2;
                                }
                                $val = $a['id'];
                            }

                            if(($this->f->fields->$fields_positions[$col]->type == 'D') and (strtolower($cell->getDataType()) != 's'))
                                 $val = date($parser->gs('sys_user_dateformat'), PHPExcel_Shared_Date::ExcelToPHP($val));
                            if(($this->f->fields->$fields_positions[$col]->type == 'T') and (strtolower($cell->getDataType()) != 's'))
                                 $val = date($parser->gs('sys_user_dateformat').' H:i', PHPExcel_Shared_Date::ExcelToPHP($val));

                            $this->f->fields->$fields_positions[$col]->newval = $val;
                        }
                        $s = ($old_id) ? $this->f->update() : $this->f->insert();
                        if($s)
                        {
                            $this->log .= $i." - ".$s."\n";
                            $this->skiped++;
                        } else
                        {
                            //  
                            if($pdf_col >= 0)
                            {
                                $val = trim($objWorksheet->getCellByColumnAndRow($pdf_col, $row)->getValue());
                                $s = ($val) ? $this->importPdf($this->f->id, $val) : '';
                                if($s) $this->log .= $i." - ".$s."\n";
                            }

                            //  
                            if($photo_col >= 0)
                            {
                                $val = trim($objWorksheet->getCellByColumnAndRow($photo_col, $row)->getValue());
                                $s = ($val) ? $this->importPhoto($this->f->id, $val, $grid) : '';
                                if($s) $this->log .= $i." - ".$s."\n";
                            }

                            if($old_id)
                            {
                                $this->updated++;
                            }
                        }
                    }

                    $objPHPExcel->disconnectWorksheets();
                    unset($objPHPExcel);

                    if($this->log) $parser->toFile($this->log, $parser->utils->userdir().'/'.'log'.date('Ymd-Hi').'.txt');
                    //return $sync_txt.'<br />'.$this->inserted.', '.$this->updated.'<br />'.implode(',',$collabels);
                    //return $sync_txt.'<br />'.$this->inserted.', '.$this->updated.'<br />'.implode(',',$fields_positions);
                    return $parser->gt('importcomplete', SYS_BASE_PATH.'main/classes', $this->inserted, $this->updated, $this->skiped).$this->mess;
                break;
            }
        }

        public function importPdf($productid = 0, $filenames = '')
        {
            global $parser;
            if(!trim($filenames)) return '';
            $ar = explode(',', $filenames);
            $path = SYS_BASE_PATH.'userdata/files/pdf/';
            $newpath = SYS_BASE_PATH.'userdata/modules/wproducts/wprod_products/';
            if(!file_exists($newpath.$productid))
            {
                if(!@mkdir($newpath.$productid, 0777))  return $parser->gt('dirnotexists');
            }
            foreach($ar as $filename)
            {
                if(!file_exists($path.$filename)) continue;
                if(file_exists($newpath.$filename)) continue;
                if (!copy($path.$filename, $newpath.$productid.'/'.$filename)) return $parser->gt('dirnotexists');
            }
        }

        public function importPhoto($productid = 0, $filenames = '', $grid)
        {
            global $parser;
            if(!trim($filenames)) return '';
            $ar = explode(',', $filenames);
            $path = SYS_BASE_PATH.'userdata/files/img/';
            $grid->objid = $productid;
            $virgin = true;
            foreach($ar as $filename)
            {
                if(!file_exists($path.$filename)) continue;
                //    ,   
                $fotoid = $parser->utils->getFieldFromSql("SELECT id FROM wprod_products_photo
                    WHERE (masterid=".$productid.")
                    AND  (notes='".$parser->conn->escape(pathinfo($filename, PATHINFO_FILENAME))."')
                    AND  (filetype='".$parser->conn->escape(strtolower(pathinfo($filename, PATHINFO_EXTENSION)))."')
                    ", 0);
                if($fotoid) continue;

                $s = $grid->saveUploadedFile($path.$filename, strtolower(pathinfo($filename, PATHINFO_EXTENSION)), $productid, $path.$filename);
                if($s) return $s;
                if($virgin && $grid->f->id)
                {
                    $virgin = false;
                    $fotoid = $parser->utils->getFieldFromSql("SELECT imageid FROM wprod_products WHERE id=".$productid, 0);
                    if(!$fotoid) $parser->conn->Execute("UPDATE wprod_products SET imageid=".$grid->f->id." WHERE id=".$productid);
                }
            }
            return '';
        }

    }

    $w = new imradprodimport();
    $w->workframe = 'gridframe';
    $w->startpath = $parser->utils->userdir(false, false).'/';
    $w->exp_objtype = 'wprod_products';
    $w->obj_classname = 'wproducts_models_products';
    $w->filter_category = (isset($_REQUEST['filter_category'])) ? $_REQUEST['filter_category'] : 0;
    $w->filter_prodfields = (isset($_REQUEST['filter_prodfields'])) ? $_REQUEST['filter_prodfields'] : 1;

    $w->addMainMenu0($parser->gt('toexcelcsv', SYS_BASE_PATH.'ext/wproducts'), 'javascript:toexcelcsv');
    $src = "<script type=\"text/javascript\">
    function toexcelcsv(obj)
    {
        filemanager_grid_postAction('exporttocsv', 0);
    }
    </script>";
    $parser->addScript($src);

    $mess = '';
    $form_action = (isset($_REQUEST['form_action'])) ? $_REQUEST['form_action'] : '';
    switch($form_action)
    {
        case 'exporttocsv':
            @set_time_limit(0);
            include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
            $grid = new wAjaxGrid();    // path
            $grid->f->objtype = 'wprod_products';
            $grid->f->_setObjType();
            $grid->f->_setFieldsFromSchema(true, true, (($grid->f->moduleid) ? SYS_BASE_PATH.'ext/'.$grid->f->moduleid : __FILE__));

            switch($w->filter_prodfields)
            {
                case 0: //  
                case 2: // 

                    // Make sql with links to external objects
                    //$q = $parser->utils->sql();
                    //$value['size']
                    $lpath = ($grid->f->moduleid) ? SYS_BASE_PATH.'ext/'.$grid->f->moduleid : '';

                    $grid->q->from('wprod_products o');
                    $grid->q->where('o.id<>0');

                    $tables = 0;
                    $fldnum = 0;

                    foreach ($grid->f->_fields as $key => $value)
                    {
                        if(!$value['export'] and ($w->filter_prodfields == 2)) continue;
                        if(!$fldnum and ($value['name'] !== 'id')) $grid->q->select('o.id', 'Id');

                        if(strlen(trim($value['type'])) > 1)
                        {
                            $res = $parser->utils->getObjInfo($value['type']);
                            if(!$res['table']) continue;
                            $grid->q->select('t'.$tables.'.'.$res['namefieldm'].' AS t'.$tables.$res['namefieldm'], $parser->gt($value['label'], $lpath));
                            $grid->q->from($res['table'].' t'.$tables);
                            $grid->q->where('o.'.$value['name'].'=t'.$tables.'.'.$res['keyfield']);
                            $tables++;
                        } else
                        {
                            $name = $value['name'];
                            if($value['lang'])
                            {
                                // Get fieldname without suffix
                                $ta = explode('_', $name);
                                if(sizeof($ta) > 1)
                                {
                                    array_pop($ta);
                                    $name = implode('_', $ta);
                                }
                                $grid->q->lselect('o.'.$name, $parser->gt($value['label'], $lpath));
                            } else $grid->q->select('o.'.$name, $parser->gt($value['label'], $lpath));
                        }
                        $fldnum++;
                    }

                break;
                case 1: //  
                    $grid->q->select('o.id', 'id');
                    $grid->q->select('o.artikul', $parser->gt('artikul'));
                    $grid->q->lselect('o.name', $parser->gt('name'));
                    $grid->q->from('wprod_products o');
                    $grid->q->where('o.id>0');
                break;
            }

            //$grid->debug = 1;
            if($w->filter_category) $grid->q->where('o.category='.$w->filter_category);
            $grid->q->orderby('o.id');
            $mess = $grid->exportExcelcsv();
        break;
    }

    $w->show();
    if($mess) print($mess);

?>