<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wprod_rights_tags');
    if(!$perm['r']) die($parser->gt('not_perms'));

    $active_tab =  (isset($active_tab)) ? $active_tab : '0';
    $cat_id =  (isset($cat_id)) ? $cat_id : '0';
    $callbackfunc =  (isset($callbackfunc)) ? $callbackfunc : '';
    $master_tagid = (isset($master_tagid)) ? $master_tagid : ((isset($_REQUEST['master_tagid'])) ? $_REQUEST['master_tagid'] : 0);
    $master_productid = (isset($master_productid)) ? $master_productid : ((isset($_REQUEST['master_productid'])) ? $_REQUEST['master_productid'] : 0);


    $action = (isset($_POST['action'])) ? $_POST['action'] : '';
    switch($action)
    {
        case 'additem':
            $itemid = (isset($_POST['itemid'])) ? $_POST['itemid'] : 0;
            if(ob_get_length()) ob_clean();
            if(!$itemid)
            {
                print(json_encode(array("mess" => 'error')));
                exit;
            }
            $f = new wproducts_models_productstags();
            $f->fields->tagid->val = $master_tagid;
            $f->fields->productid->val = $itemid;
            $err_mess = $f->insert();
            print(json_encode(array("mess" => $err_mess)));
            exit;
        break;
    }


    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
    $w = new wAjaxGrid();
    $filter_tagid = (isset($_REQUEST['filter_tagid'])) ? $_REQUEST['filter_tagid'] : '';

    if($master_tagid) $filter_tagid = $master_tagid;


    $w->f = new wproducts_models_productstags();
    $w->edit_table_alias = 'o';
    //$w->caption = $parser->gt('wprod_products_tags', __FILE__);
    $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_products_tags'", '');

    $w->q->select('o.id',  $parser->gt('id'));
    if(!$master_tagid) $w->q->lselect('t.name AS tname', $parser->gt('tag'));
    if(!$master_productid) $w->q->lselect('p.name AS tname', $parser->gt('product'));
    $w->q->from('wprod_products_tags o');
    $w->q->from('wprod_products p');
    $w->q->from('wprod_tags t');
    $w->q->where("o.id<>'0'");
    $w->q->where('o.productid=p.id');
    $w->q->where('o.tagid=t.id');
    $w->q->orderby('o.id');

    if($filter_tagid)
    {
        $mfilter_tagid = $parser->utils->addQuots($filter_tagid);
        $w->q->where("o.tagid IN(".$mfilter_tagid.")");
        $w->f->extra_deleteAll_sql .= "AND tagid IN(".$mfilter_tagid.") ";
        $w->f->fields->tagid->val = $filter_tagid;
        $w->f->fields->tagid->refval = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff.' FROM wprod_tags WHERE id='.$filter_tagid, '');
        $w->f->fields->tagid->ro = 1;
    }

    if($master_productid)
    {
        $mfilter_productid = $parser->utils->addQuots($master_productid);
        $w->q->where("o.productid IN(".$mfilter_productid.")");
        $w->f->extra_deleteAll_sql .= "AND productid IN(".$mfilter_productid.") ";
        $w->f->fields->productid->val = $master_productid;
        $w->f->fields->productid->refval = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff.' FROM wprod_products WHERE id='.$master_productid, '');
        $w->f->fields->productid->ro = 1;
    }

    if(!$master_tagid and !$master_productid)
    {
        $w->popup_script = true;
        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_tagid';
        $pars['emptyval'] = 0;
        $pars['tree_btn'] = 0;
        $pars['emptyrefval'] = $parser->gt('all');
        $pars['val'] = $filter_tagid;
        $pars['objtype'] = 'wprod_tags';
        $w->addCell($parser->utils->finder($pars));
    }

    $w->addSearchField('o.tagid', $parser->gt('tag'), 'wprod_tags');
    $w->addSearchField('o.productid', $parser->gt('product'), 'wprod_products');

    $w->editing = $perm['u'];
    $w->adding = $perm['c'];
    $w->copying = $perm['c'];
    $w->deleting = $perm['d'];
    $w->multiselect = $perm['d'];


    $w->addHidden('active_tab', $active_tab);
    $w->addHidden('cat_id', $cat_id);
    $w->addHidden('callbackfunc', $callbackfunc);
    $w->addHidden('master_tagid', $master_tagid);
    $w->addHidden('master_productid', $master_productid);

    if($master_tagid)
    {
        $w->addMainMenu0($parser->gt('catalog'), $action = 'javascript:openCatalog');

        $src = "<script type=\"text/javascript\">
        function openCatalog(obj)
        {
            openWinc('".$parser->makeUrl('wprod_products_catalog')."', 'onselect=additem');
        }
        function additem(itemid)
        {
            $.post('index.php',
            $.param({'pageid':'".$parser->pageId."',
            'action':'additem',
            'active_tab':'".$active_tab."',
            'cat_id':'".$cat_id."',
            'callbackfunc':'".$callbackfunc."',
            'master_tagid':'".$master_tagid."',
            'master_productid':'".$master_productid."',
            'itemid':itemid}),
            function(data)
            {
                if(data.mess != '')
                {
                    //alert(data.mess);
                } else  global_".$w->container.".loadxml(0);
            }, 'json');
        }
        </script>";
        $parser->addScript($src);
        $src = SYS_BASE_URL.'main/js/popup.js';
        $parser->addScript($src);


    }




    $w->show();
?>