<?php


    include_once(SYS_BASE_PATH.'main/classes/wcatalog.class.php');
    class wtablecard extends wCatalog
    {
        //public $perm = array('c' => 0, 'r' => 0, 'u' => 0, 'd' => 0);
        public function _titleframe()
        {
            global $parser;
            $this->title = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_obj_prop_products'", '');
        }

        public function _navigation()
        {
            global $parser;
            $cat_id = (isset($_REQUEST['cat_id'])) ? $_REQUEST['cat_id'] : '';

            $start_prop = (isset($_REQUEST['start_prop'])) ? $_REQUEST['start_prop'] : 'wprod_obj_prop_products';

            include_once(SYS_BASE_PATH.'main/classes/wajaxtree.class.php');
            $tree = new wAjaxTree();
            include_once(SYS_BASE_PATH.'main/objects/objtypes.class.php');
            $tree->f = new wObjtypes();
            $tree->edit_keyfield = 'objtype';

            $tree->startfrom = $start_prop;
            $tree->q->select('objtype');
            $tree->q->select('name', '', array('lang' => true));
            $tree->q->select('isfolder');
            $tree->q->select('parent');
            $tree->q->from('sys_objtypes');
            $tree->q->where("objtype<>'0'");
            $tree->q->where("parent=:parent:");
            $tree->q->lorderby('name');

            $tree->editing = true;
            $tree->adding = true;
            $tree->deleting = true;

            $tree->addHidden('cat_id', $cat_id);
            $tree->addHidden('start_prop', $start_prop);
            $tree->leaf_func = 'leafclickm';
            $tree->folder_func = 'leafclickm';
            //$tree->unselect = true;

            $src = "<script type=\"text/javascript\">
            function leafclickm(id, treetype)
            {
                $.post('index.php',
                $.param({'pageid':'sys_utils_propinfo',
                'action':'getpropinfo',
                'showmaster':1,
                'proptype':id}),
                function(data)
                {
                    try
                    {
                        global_ajaxgrid.setProperty('colnames', data.colnames);
                        reloadgrid(id, treetype);
                    } catch(e) {}
                }, 'json');
            }
            ";
            $src .= $this->_script;
            $src .= "</script>\n";
            $parser->addScript($src);
            $tree->show();

            return '';
        }

        public function _content()
        {
            global $parser;
            $cat_id = (isset($_REQUEST['cat_id'])) ? $_REQUEST['cat_id'] : '';
            $subcat_id = (isset($_REQUEST['subcat_id'])) ? $_REQUEST['subcat_id'] : '';

            include_once(SYS_BASE_PATH.'main/objects/props.class.php');
            include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
            $grid = new wAjaxGrid();
            $grid->visible = false;
            $grid->f = new wProps($subcat_id, 1);
            //$grid->f->setFieldVal('masterid', $cat_id);
            $grid->f->setFieldVal('proptype', $subcat_id);
            $grid->q = $grid->f->sql_object;
            //$grid->q->where('d.masterid='.$cat_id);
            $grid->q->where("d.proptype='".$subcat_id."'");

            //$grid->f->setFieldAttr('masterid', 'refval', $parser->utils->getFieldFromSql('SELECT shortname FROM wcomm_company WHERE id='.$company, ''));
            //$grid->f->setFieldAttr('masterid', 'hide', true);

            $grid->adding = true;
            $grid->editing = true;
            $grid->deleting = true;
            $grid->multiselect = 1;
            //$grid->debug = true;

            $grid->addHidden('subcat_id', $subcat_id);
            $grid->addHidden('cat_id', $cat_id);
            $grid->caption = $parser->utils->getFieldFromSql("SELECT name_".$parser->lang_suff." FROM sys_objtypes WHERE objtype='".$subcat_id."'", '');
            $grid->show();

        }

    }


    $cat = new wtablecard('wprod_products');
    $cat->showTable();



?>