<?php
        // Check Rights
        if(!$parser->getUserId()) die($parser->gt('not_perms'));
        $perm = $parser->checkPerms('wprod_rights_reviews');
        if(!$perm['r']) die($parser->gt('not_perms'));
        include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
        $w = new wAjaxGrid();
        $filter_productid = (isset($_REQUEST['filter_productid'])) ? $_REQUEST['filter_productid'] : '';
        $productid = (isset($productid)) ? $productid : ((isset($_REQUEST['productid'])) ? $_REQUEST['productid'] : 0);
        $active_tab =  (isset($active_tab)) ? $active_tab : '0';
        $cat_id =  (isset($cat_id)) ? $cat_id : '0';
        $callbackfunc =  (isset($callbackfunc)) ? $callbackfunc : '';

        $filter_published = (isset($_REQUEST['filter_published'])) ? $_REQUEST['filter_published'] : '';
        $filter_period = (isset($_REQUEST['filter_period'])) ? $_REQUEST['filter_period'] : 1;

        if($productid)
        {
            $filter_productid = $productid;
            $filter_period = 0;
        }


        $w->f = new wproducts_models_reviews();
        $w->edit_table_alias = 'o';
        //$w->caption = $parser->gt('wprod_reviews', __FILE__);
        $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_reviews'", '');

        $w->q->select('o.id',  $parser->gt('id'));
        $w->q->select('o.title', $parser->gt('name'), array('edit' => $perm['u']));
        if(!$productid) $w->q->lselect('p.name', $parser->gt('product'));
        $w->q->select('o.creaton', $parser->gt('createdon'));
        $w->q->lselect('u.name', $parser->gt('creatby'));
        $w->q->select('o.published', $parser->gt('published'));
        $w->q->from('wprod_reviews o');
        $w->q->from('wprod_products p');
        $w->q->from('sys_objects u');
        $w->q->where("o.id<>'0'");
        $w->q->where("o.creatby=u.objid");
        $w->q->where("o.productid=p.id");
        $w->q->orderby('o.title');

        if($filter_period)
        {
             $per = $parser->utils->getPeriod($filter_period, true);
             $w->q->where("o.creaton ".$per);
             $w->f->extra_deleteAll_sql .= "AND (creaton ".$per.")";
        }
        switch($filter_published)
        {
            case 1:	 $w->q->where("o.published=1");
                     $w->f->extra_deleteAll_sql .= "AND published=1 ";
            break;
            case 2:	 $w->q->where("o.published=0");
                     $w->f->extra_deleteAll_sql .= "AND published=0 ";
            break;
        }
        if($filter_productid)
        {
            $mfilter_productid = $parser->utils->addQuots($filter_productid);
            $w->q->where("o.productid IN(".$mfilter_productid.")");
            $w->f->extra_deleteAll_sql .= "AND productid IN(".$mfilter_productid.") ";
            $w->f->fields->productid->val = $filter_productid;
            $w->addingpars .= '&productid='.$filter_productid;
        }
        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_period';
        $pars['val'] = $filter_period;
        $w->addCell($parser->utils->periodMenu($pars));

        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_published';
        $pars['val'] = $filter_published;
        $pars['options'] = array($parser->gt('all'), $parser->gt('published'), $parser->gt('notpublished'));
        $w->addCell($parser->utils->dropdownMenu($pars));

        if(!$productid)
        {
            $w->popup_script = true;
            $pars = array();
            $pars['onchange'] = $w->container."_postAction('',0)";
            $pars['name'] = 'filter_productid';
            $pars['emptyval'] = 0;
            $pars['tree_btn'] = 0;
            $pars['width'] = 180;
            $pars['emptyrefval'] = $parser->gt('allproducts');
            $pars['val'] = $filter_productid;
            $pars['objtype'] = 'wprod_products';
            $w->addCell($parser->utils->finder($pars));
        }
        $w->addSearchField('o.title', $parser->gt('name'), 'C');

        $w->editing = $perm['u'];
        $w->adding = $perm['c'];
        $w->copying = $perm['c'];
        $w->deleting = $perm['d'];
        $w->multiselect = $perm['d'];

        $w->addHidden('productid', $productid);
        $w->addHidden('active_tab', $active_tab);
        $w->addHidden('cat_id', $cat_id);
        $w->addHidden('callbackfunc', $callbackfunc);

        $w->cardurl = $parser->makeUrl('wprod_reviews_card');


        $w->show();
?>