<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wprod_rights_tags');
    if(!$perm['r']) die($parser->gt('not_perms'));
    $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;

    include_once(SYS_BASE_PATH.'main/classes/wcatalog.class.php');
    class wtablecard extends wCatalog
    {
        public $perm = array('c' => 0, 'r' => 0, 'u' => 0, 'd' => 0);
        public function _titleframe()
        {
            global $parser;

            $userid = $parser->getUserId();
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;

            $parent = (isset($_REQUEST['parent'])) ? $_REQUEST['parent'] : 0;

            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';

            $this->addHidden('callbackfunc', $callbackfunc);

            $this->addHidden('parent', $parent);

            $this->f = new wproducts_models_tags();
            $this->title = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_tags'", '');

            $this->extra_from = '';
            if($userid !== 'sys_superadmin') $this->extra_where = "";

            $this->addMenu(0, $parser->gt('card'), !$active_tab);
            $this->addMenu(1, $parser->gt('products'), ($active_tab == 1));
            $this->addMenu('main/system/log.php', $parser->gt('log'), ($active_tab === 'main/system/log.php'));
            //$section = $this->addMoreMenuSection($parser->gt('objects'));
            //$this->addMoreMenuSectionItem($section, 'ext/xxx/lib/xxx_xxxlist.php', $parser->gt('xxx'));
        }


        public function _content()
        {
            global $parser;
            $userid = $parser->getUserId();
            $cat_id = (isset($_REQUEST['cat_id'])) ? $_REQUEST['cat_id'] : '';
            $objid = (isset($_REQUEST['objid'])) ? $_REQUEST['objid'] : '';
            $card_onload_par = (isset($_REQUEST['card_onload_par'])) ? $_REQUEST['card_onload_par'] : '';
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : '';
            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';
            if(!$this->adding and !$cat_id) return $parser->gt('no_data_found');

            if(!is_numeric($active_tab) and $active_tab)
            {
                $objtype = 'wprod_tags';
                $file = SYS_BASE_PATH.$active_tab;
                if(file_exists($file)) include_once($file); else return 'File not found at: '.$file;
            } else
            switch($active_tab)
            {
                case 0:
                    $parser->addScript(SYS_BASE_URL.'main/js/popup.js');

                    $f = new wproducts_models_tags($this->objtype, $cat_id);
                    $f->id = $cat_id;
                    $f->buttonpanel = 'buttonpanelm';
                    $f->only_card = true;
                    $f->container = 'wprod_tags_cat';
                    $form_action = (isset($_POST['form_action'])) ? $_POST['form_action'] : '';

                    switch($form_action)
                    {
                        case 'edit':
                            $f->read();
                            $s = $f->update(true);
                            if($s) $f->error_mess = $s;
                            if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                        break;
                        case 'insert':
                            $s = $f->insert(true);
                            if($s) $f->error_mess = $s;
                            else
                            {
                                if($card_onload_par) $f->onCopy($card_onload_par);
                                if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                                return "<SCRIPT LANGUAGE=\"JavaScript\">navigatetoid('".$f->id."');</SCRIPT>";
                            }
                        break;
                    }

                    $f->addHidden('cat_id', $cat_id);
                    $f->addHidden('active_tab', $active_tab);
                    $f->addHidden('callbackfunc', $callbackfunc);
                    $parser->addScript("<script type='text/javascript'>
                    function form_submit()
                    {
                        var btn = document.getElementById('submitbutton');
                        if(btn)
                        {
                            btn.value = '".$parser->gt('loading')."...';
                            btn.disabled = true;
                        }
                        $('#form_dialog_".$f->container."').submit();
                    }
                        </script>");
                    $f->en_autocomplete = true;
                    if($cat_id)
                    {
                        $f->addHidden('form_action', 'edit');
                        $f->addButton($parser->gt('save'), 'form_submit()', 'submitbutton', 'button');
                    } else
                    {
                        if($this->perm['c'])
                        {
                            if($card_onload_par) $f->onBeforeCopy($card_onload_par);

                            $parent = (isset($_REQUEST['parent'])) ? $_REQUEST['parent'] : 0;
                            $f->fields->parent->val = $parent;

                            $f->addHidden('form_action', 'insert');
                            $f->addHidden('card_onload_par', $card_onload_par);
                            $f->addButton($parser->gt('insert'), 'form_submit()', 'submitbutton', 'button');
                            $f->addButton($parser->gt('cancel'), "navigateto('last')", '', 'button');
                        }
                    }

                    return $f->showForm();
                break;
                case 1:
                    if(!$cat_id) die('');
                    $master_tagid = $cat_id;
                    include_once(SYS_BASE_PATH.'ext/wproducts/lib/productstagslist.php');
                break;
            }
        }
    }

    $cat = new wtablecard('wprod_tags');
    $cat->notreeframe = true;
    $cat->navigation = true;
    $cat->navibuttons = true;
    $cat->extra_from = '';
    $cat->extra_where = '';
    $cat->adding = $perm['c'];
    $cat->deleting = $perm['d'];
    $cat->perm = $perm;

    $cat->showTable(0);


?>