<?php
        // Check Rights
        if(!$parser->getUserId()) die($parser->gt('not_perms'));
        $perm = $parser->checkPerms('wprod_rights_products');
        if(!$perm['r']) die($parser->gt('not_perms'));
        $filter_manufacter = (isset($_REQUEST['filter_manufacter'])) ? $_REQUEST['filter_manufacter'] : '';
        $filter_published = (isset($_REQUEST['filter_published'])) ? $_REQUEST['filter_published'] : '';
        $filter_color = (isset($_REQUEST['filter_color'])) ? $_REQUEST['filter_color'] : '';

        include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
        $w = new wAjaxGrid();
        $w->f = new wproducts_models_products();
        $w->edit_table_alias = 'o';
        //$w->caption = $parser->gt('wprod_categories', __FILE__);
        $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wprod_products'", '');
        //$w->en_mainmenu = false;
        if($perm['c'])
        {
            $w->addMainMenu0($parser->gt('import', SYS_BASE_PATH.'main/objects'), 'javascript:dataimport');
        	$src = SYS_BASE_URL.'main/js/clean/popup.js';
            $parser->addScript($src);
            $src = "
            <script type='text/javascript'>
            function dataimport(obj)
            {
                openWinc('".$parser->makeUrl('sys_admin_utils_import')."', 'callbackfunc=self.opener.global_".$w->container.".loadxml(0)&exp_objtype=wprod_products&obj_classname=wproducts_models_products');
            }
            </script>
            ";
            $parser->addScript($src);
        }

        $fn = __FILE__;
        $par = array('edit' => $perm['u']);

        $w->q->select('o.id',  $parser->gt('id'));
        $w->q->select('o.artikul', $parser->gt('artikul', $fn), $par);
        $w->q->select('o.model', $parser->gt('model', $fn), $par);
        $w->q->select('o.name', $parser->gt('name', $fn), array('lang' => true, 'edit' => $perm['u']));

        $b = $parser->utils->getFieldsFromSql("SELECT flt1, flt2, flt3, str1_".$parser->lang_suff." FROM sys_objects WHERE objid='".$parser->gs('wprod_setting_curr')."'", array(0,0,0,''), 'num');
        $w->q->lselect('c.name AS cname', $parser->gt('category', $fn));
        if($parser->gt('wprod_setting_showtaxes'))  $w->q->select('o.taxprice', $parser->gt('taxprice', $fn).' '.$b[3]);
            else $w->q->select('o.price', $parser->gt('price', $fn).' '.$b[3]);
        $w->q->select('o.income-o.expense AS qty', $parser->gt('qtys', $fn));
        $w->q->select('o.masterid', 'ERP Id');
        $w->q->select('o.url', $parser->gt('url'), array('edit' => $perm['u']));
        $w->rowclass_col = $w->q->select('o.color', $parser->gt('color'), array('hide' => 1));

        if($filter_color)
        {
            $w->q->where("o.color='".$filter_color."'");
            $w->f->extra_deleteAll_sql .= "AND color='".$filter_color."' ";
            $w->f->setFieldVal('color', $filter_color);
        }
        switch($filter_published)
        {
            case 1:     $w->q->where("o.published=1");
                     $w->f->extra_deleteAll_sql .= "AND published=1 ";
            break;
            case 2:     $w->q->where("o.published=0");
                     $w->f->extra_deleteAll_sql .= "AND published=0 ";
            break;
        }
        if($filter_manufacter)
        {
            $mfilter_manufacter = $parser->utils->addQuots($filter_manufacter);
            $w->q->where("o.manufacter IN(".$mfilter_manufacter.")");
            $w->f->extra_deleteAll_sql .= "AND manufacter IN(".$mfilter_manufacter.") ";
            $w->f->setFieldVal('manufacter', $filter_manufacter);
        }
        $w->q->from('wprod_products o');
        $w->q->from('wprod_categories c');
        $w->q->where("o.id<>'0'");
        $w->q->where("o.category=c.id");

        $w->q->lorderby('o.name');

        $pars['name'] = 'filter_color';
        $pars['onchange'] = "ajaxgrid_postAction('',0)";
        $pars['val'] = $filter_color;
        $pars['colored'] = true;
        $pars['options'] = array($parser->gt('allcolors'));
        $w->addCell($parser->utils->dropdownMenu($pars));

        $w->popup_script = true;
        $pars = array();
        $pars['name'] = 'filter_manufacter';
        $pars['val'] = $filter_manufacter;
        $pars['emptyval'] = 0;
        $pars['tree_btn'] = 0;
        $pars['emptyrefval'] = $parser->gt('allmanufacter',__FILE__);
        $pars['onchange'] = "ajaxgrid_postAction('',0)";
        $pars['objtype'] = 'wprod_brands';
        $w->addCell($parser->utils->finder($pars));

        $pars['name'] = 'filter_published';
        $pars['onchange'] = "ajaxgrid_postAction('',0)";
        $pars['val'] = $filter_published;
        $pars['options'] = array($parser->gt('allenabled',__FILE__), $parser->gt('yesitis'), $parser->gt('noitisnot'));
        $w->addCell($parser->utils->dropdownMenu($pars));

        $w->addSearchField('o.artikul', $parser->gt('artikul'), 'C');
        $w->addSearchField('o.model', $parser->gt('model'), 'C');
        $w->laddSearchField('o.name', $parser->gt('name'));

        $w->addSearchField('o.income-o.expense', $parser->gt('quantity'), 'F');
        if($parser->gt('wcomm_setting_showtaxes')) $w->addSearchField('o.taxprice', $parser->gt('taxprice'), 'F');
            else $w->addSearchField('o.price', $parser->gt('price'), 'F');
        $w->addSearchField('o.comments', $parser->gt('comments'), 'I');
        $w->addSearchField('o.rating', $parser->gt('rating'), 'I');
        $w->addSearchField('o.photos', $parser->gt('photos'), 'I');
        $w->addSearchField('o.viewed', $parser->gt('viewed'), 'I');
        $w->addSearchField('o.prodtype', $parser->gt('prodtype'), 'wprod_prodtypes');
        $w->addSearchField('o.manufacter', $parser->gt('manufacter'), 'wprod_brands');
        $w->addSearchField('o.published', $parser->gt('published'), 'L');
        $w->addSearchField('o.newitem', $parser->gt('newitem'), 'L');
        $w->addSearchField('o.ourchoice', $parser->gt('ourchoice'), 'L');
        $w->addSearchField('o.needdelivery', $parser->gt('needdelivery'), 'L');

        $w->editing = $perm['u'];
        $w->adding = $perm['c'];
        $w->copying = $perm['c'];
        $w->deleting = $perm['d'];
        $w->multiselect = $perm['d'];


        $w->cardurl = $parser->makeUrl('wprod_products_card');

        if($perm['u'])
        {
            $form_action = (isset($_REQUEST['form_action'])) ? $_REQUEST['form_action'] : '';
            switch($form_action)
            {
                case 'makeurls':
                    $rs = $parser->conn->Execute("SELECT id, name_".$parser->lang_suff.", url FROM wprod_products WHERE (id>0)");
                    $output = '';
                    while($row = $rs->FetchRow())
                    {
                        $url = trim($row[2]);
                        if($url) continue;
                        $url = $parser->utils->ruTranslit(mb_strtolower(trim($row[1]), $this->config['charset']));
                        $url = str_replace(array(" ", "_", "&", "+", ".", ",", "/", "*", "'", "\"", "%", "(", ")", "?"),
                                           array("-", "-", "-", "-", "-", "-", "-", "-", "-", "-",  "-", "-", "-", "-"),
                                           $url);
                        $url = preg_replace('/[\-]+/','-', $url);
                        $url = trim($url, '-');
                        $url = preg_replace('/[^A-Za-z0-9\-]/', '', $url);

                        // Check uniqueness in Products
                        $n = $parser->utils->getFieldFromSql("SELECT id FROM wprod_products
                                                              WHERE (url='".$this->conn->escape($url)."')
                                                              AND (id<>".$row[0].")", 0);
                        if(!$n)
                        {
                            // Check uniqueness in Categoris
                            $n = $parser->utils->getFieldFromSql("SELECT id FROM wprod_categories
                                                                  WHERE (url='".$this->conn->escape($url)."')
                                                                  AND (id>0)", 0);

                        }
                        if(!$n)
                        {
                            // Check uniqueness in Pages
                            $n = $parser->utils->getFieldFromSql("SELECT objid FROM sys_objects
                                                                  WHERE (pagealias='".$this->conn->escape($url)."')
                                                                  AND (objtype='sys_elements_pages')", 0);

                        }

                        if($n) $url .= '-product-'.$row[0];
                        $parser->conn->Execute("UPDATE wprod_products set url='".$url."' WHERE id=".$row[0]);
                    }
                break;
                case 'clearurls':
                        $parser->conn->Execute("UPDATE wprod_products set url=''");
                break;
            }

            $w->addMainMenu0($parser->gt('functions'));
            $w->addMainMenu1($parser->gt('makeurls'), $action = 'javascript:makeurls');
            $w->addMainMenu1($parser->gt('clearurls'), $action = 'javascript:clearurls');

            $src = "<script type=\"text/javascript\">
            function makeurls(obj)
            {
                ".$w->container."_postAction('makeurls', 0);
            }
            function clearurls(obj)
            {
                var q = window.confirm(\"".$parser->gt('atclearurls')."\");
                if(!q) return;
                ".$w->container."_postAction('clearurls', 0);
            }
        	</script>";
            $parser->addScript($src);
        }

        $w->show();
?>