<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class wproducts_models_reviews extends wPrototype
{

public function __construct($objtype = '', $id = '')
{
    $this->id = $id;
    parent::__construct('wprod_reviews');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
    $this->showformTinymceScript = true;
    $this->richedit_height = 500;
    $this->extendedTinymce = true;
}


protected function _onBeforeInsert()
{
    global $parser;
    $this->setFieldNewVal('creatby', $parser->getUserId());
    $this->setFieldNewVal('creaton', $parser->utils->toDate('', true));
    return '';
}

protected function _onDelete()
{
    global $parser;
    $fn = SYS_BASE_PATH.'userdata/modules/wproducts/wprod_reviews/'.$this->id;
    if(file_exists($fn)) $parser->utils->removeDir($fn, true);
    return '';
}

/*
protected function _onUpdate()
{
    // Update Extra fields
    $pars = array();
    $pars['table'] = 'wprod_reviews_fields';
    $pars['objid'] = $this->_fields['objtype']['val'];
    $this->insertExtraFields($pars);
    return '';
}
*/

/*
protected function _onBeforeShowForm()
{
    global $parser;
    if(!$this->id)
    {
        $this->fields->starton->val = $parser->utils->toDate('');
        $this->fields->creatby->val = $parser->getUserId();
    } else
    {
        // Print extra fields
        $ro = false;
        $pars = array();
        $pars['tabname'] = $parser->gt('extrafields');
        $pars['table'] = 'wprod_reviews_fields';
        $pars['objid'] = $this->_fields['objtype']['val'];
        $pars['ro'] = $ro;
        $this->showExtraFields($pars);
    }
    return '';
}
*/

public function onBeforeCopy($id = 0)
{
    parent::onBeforeCopy($id);
    $this->fields->creatby->val = 0;
    $this->fields->creatby->refval = '';
    $this->fields->creaton->val = '';
    return '';
}

public function onCopy($id = 0)
{
    //global $parser;
    // Copy subobjects from original object

    return '';
}

}

?>